<?php
namespace Teknisa\OPL\Modules\ApuracaoEfetivacao\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class EfetivacaoService {
    
    protected $connection;
    protected $newCode;
    
    public function __construct($entityManager, $newCode, $environment, $dataSourceManager) {
        $this->connection = $entityManager->getConnection();
        $this->newCode = $newCode;
        $this->environment = $environment;
        $this->dataSourceManager = $dataSourceManager;
    }
    
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
        $this->connection->rollBack();
    }
    
    public function selectCotacaoWithParamNull($params) {
        $sql = "SELECT ITMAPURPREC.CDFORNITMAP, FORNECEDOR.NMFANTFORN, FORNECEDOR.NRINSJURFORN, FORNECEDOR.IDTPIJURFORN, (ITMAPURPREC.CDREGITMAP||' - '||REGIAO.NMREGIAO) AS CDNMREGIAO, (PRODUTO.CDARVPROD||' - '||PRODUTO.NMPRODUTO) AS CDNMPRODUTO, ITMAPURPREC.NRSEQITMAP, ITMAPURPREC.CDCENTITMAP, ITMAPURPREC.CDREGITMAP, REGIAO.NMREGIAO, ITMAPURPREC.NRCOLEITMAP, PRODUTO.CDPRODESTO, ITMAPURPREC.CDPRODITMAP, PRODUTO.CDARVPROD, PRODUTO.NMPRODUTO, ITMAPURPREC.CDMARCITMAP, MARCA.NMMARCA, ITMAPURPREC.VRPRECUNIAP, ITMAPURPREC.VRPRECECOAP AS PRECOECON, ITMAPURPREC.VRPRECONPIAP AS PRECOECONPI, SUM(ITMAPURPREC.QTSOLACOMP) AS QTACOMP, MAX(ITMAPURPREC.IDITMSELAPUR) AS IDITMSELAPUR, DECODE (PARASUPRI.IDTIPOAPUR, NULL, ITMAPURPREC.VRPRECUNIAP, '1', ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP) AS ORDENA, FORNECEDOR.SGUNIDADE, NVL(MINFORNREG.QTMINFORNREG, FORNECEDOR.QTMINAUTFOT) AS QTMINAUTFOT, DECODE(MINFORNREG.QTMINFORNREG, NULL, 'F', 'R') AS IDQTMINFORN, NVL(MINFORNREG.VRMINFORNREG, FORNECEDOR.VRMINAUTFOR) AS VRMINAUTFOR, DECODE(MINFORNREG.VRMINFORNREG, NULL, 'F', 'R') AS IDVRMINFORN, PRODUTO.VRFATOCONV, ITMAPURPREC.VRPRECUNIAP/PRODUTO.VRFATOCONV PRODUNDIVFATCO, 0 QTESTOSEGU, 0 CALC_ESTO FROM ITMAPURPREC, PRODUTO, FORNECEDOR, MINFORNREG, REGIAO, MARCA, PARASUPRI WHERE (PARASUPRI.CDFILIAL = :P_CDCENTCMP) AND (ITMAPURPREC.CDCENTITMAP = :P_CDCENTCMP) AND (ITMAPURPREC.NRSEQITMAP = :P_NRSEQAPUR) AND ((PRODUTO.CDPRODESTO = :P_CDPRODESTO) OR (:P_CDPRODESTO = 'T')) AND (ITMAPURPREC.CDMARCITMAP = MARCA.CDMARCA) AND (ITMAPURPREC.CDFORNITMAP = FORNECEDOR.CDFORNECED) AND (ITMAPURPREC.CDREGITMAP = MINFORNREG.CDREGIAO(+)) AND (ITMAPURPREC.CDFORNITMAP = MINFORNREG.CDFORNECED(+)) AND (ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO) AND (ITMAPURPREC.CDREGITMAP = REGIAO.CDREGIAO) GROUP BY ITMAPURPREC.CDFORNITMAP, FORNECEDOR.NMFANTFORN, FORNECEDOR.NRINSJURFORN, FORNECEDOR.IDTPIJURFORN, ITMAPURPREC.NRSEQITMAP, ITMAPURPREC.CDCENTITMAP, ITMAPURPREC.CDREGITMAP, REGIAO.NMREGIAO, ITMAPURPREC.NRCOLEITMAP, PRODUTO.CDPRODESTO, PRODUTO.NMPRODUTO, ITMAPURPREC.CDPRODITMAP, PRODUTO.CDARVPROD, ITMAPURPREC.CDMARCITMAP, MARCA.NMMARCA, ITMAPURPREC.VRPRECUNIAP, ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP, DECODE (PARASUPRI.IDTIPOAPUR, NULL, ITMAPURPREC.VRPRECUNIAP, '1', ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP), FORNECEDOR.SGUNIDADE, NVL(MINFORNREG.QTMINFORNREG, FORNECEDOR.QTMINAUTFOT), DECODE(MINFORNREG.QTMINFORNREG, NULL, 'F', 'R'), NVL(MINFORNREG.VRMINFORNREG, FORNECEDOR.VRMINAUTFOR), DECODE(MINFORNREG.VRMINFORNREG, NULL, 'F', 'R'), PRODUTO.VRFATOCONV ORDER BY DECODE (PARASUPRI.IDTIPOAPUR, NULL, ITMAPURPREC.VRPRECUNIAP, '1', ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP)";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function selectCotacaoWithParamNotNull($params) {
        $sql = "SELECT ITMAPURPREC.CDFORNITMAP, FORNECEDOR.NMFANTFORN, FORNECEDOR.NRINSJURFORN, FORNECEDOR.IDTPIJURFORN,(ITMAPURPREC.CDREGITMAP ||' - ' ||REGIAO.NMREGIAO) AS CDNMREGIAO, (PRODUTO.CDARVPROD ||' - ' ||PRODUTO.NMPRODUTO) AS CDNMPRODUTO, ITMAPURPREC.NRSEQITMAP, ITMAPURPREC.CDCENTITMAP, ITMAPURPREC.CDREGITMAP, REGIAO.NMREGIAO, ITMAPURPREC.NRCOLEITMAP, ITMAPURPREC.CDPRODITMAP, PRODUTO.CDPRODESTO, PRODUTO.CDARVPROD, PRODUTO.NMPRODUTO, ITMAPURPREC.CDMARCITMAP, MARCA.NMMARCA, ITMAPURPREC.VRPRECUNIAP, ITMAPURPREC.VRPRECECOAP AS PRECOECON, ITMAPURPREC.VRPRECONPIAP AS PRECOECONPI, SUM(ITMAPURPREC.QTSOLACOMP) AS QTACOMP, MAX(ITMAPURPREC.IDITMSELAPUR) AS IDITMSELAPUR, DECODE (PARASUPRI.IDTIPOAPUR, NULL, ITMAPURPREC.VRPRECUNIAP, '1', ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP) AS ORDENA, FORNECEDOR.SGUNIDADE, NVL(MINFORNREG.QTMINFORNREG, FORNECEDOR.QTMINAUTFOT) AS QTMINAUTFOT, DECODE(MINFORNREG.QTMINFORNREG, NULL, 'F', 'R') AS IDQTMINFORN, NVL(MINFORNREG.VRMINFORNREG, FORNECEDOR.VRMINAUTFOR) AS VRMINAUTFOR, DECODE(MINFORNREG.VRMINFORNREG, NULL, 'F', 'R') AS IDVRMINFORN, PRODUTO.VRFATOCONV, ITMAPURPREC.VRPRECUNIAP/PRODUTO.VRFATOCONV PRODUNDIVFATCO, CASE WHEN CEIL(NVL(ESTOSEGU.QTESTOSEGU, 0)/PRODUTO.VRFATOCONV) < 0 THEN 0 ELSE CEIL(NVL(ESTOSEGU.QTESTOSEGU, 0)/PRODUTO.VRFATOCONV) END AS QTESTOSEGU, CASE WHEN CEIL(NVL(ESTOSEGU.QTESTOSEGU - CALC_ESTOQ_CONS(:P_CDFILIOPELOG, RELACPRODOL.CDPRODARVOL, SYSDATE + 1), 0)/PRODUTO.VRFATOCONV) < 0 THEN 0 ELSE CEIL(NVL(ESTOSEGU.QTESTOSEGU - CALC_ESTOQ_CONS(:P_CDFILIOPELOG, RELACPRODOL.CDPRODARVOL, SYSDATE + 1), 0)/PRODUTO.VRFATOCONV) END AS CALC_ESTO FROM ITMAPURPREC, PRODUTO, FORNECEDOR, MINFORNREG, REGIAO, MARCA, PARASUPRI, ( SELECT QTESTOSEGU, CDPRODESTO FROM ESTOSEGU E WHERE E.CDFILIAL = :P_CDFILIOPELOG) ESTOSEGU, RELACPRODOL WHERE ( PARASUPRI.CDFILIAL = :P_CDCENTCMP ) AND ( ITMAPURPREC.CDCENTITMAP = :P_CDCENTCMP ) AND ( ITMAPURPREC.NRSEQITMAP = :P_NRSEQAPUR ) AND ( ( PRODUTO.CDPRODESTO = :P_CDPRODESTO ) OR ( :P_CDPRODESTO = 'T' ) ) AND ( ITMAPURPREC.CDMARCITMAP = MARCA.CDMARCA ) AND ( ITMAPURPREC.CDFORNITMAP = FORNECEDOR.CDFORNECED ) AND ( ITMAPURPREC.CDREGITMAP = REGIAO.CDREGIAO ) AND ( ITMAPURPREC.CDREGITMAP = MINFORNREG.CDREGIAO(+) ) AND ( ITMAPURPREC.CDFORNITMAP = MINFORNREG.CDFORNECED(+) ) AND ( ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO ) AND ( ESTOSEGU.CDPRODESTO(+) = PRODUTO.CDPRODESTO ) AND ( RELACPRODOL.CDPRARVORIG(+) = ITMAPURPREC.CDPRODITMAP ) AND ( RELACPRODOL.CDMARCA(+) = ITMAPURPREC.CDMARCITMAP ) GROUP BY ITMAPURPREC.CDFORNITMAP, FORNECEDOR.NMFANTFORN, FORNECEDOR.NRINSJURFORN, FORNECEDOR.IDTPIJURFORN, ITMAPURPREC.NRSEQITMAP, ITMAPURPREC.CDCENTITMAP, ITMAPURPREC.CDREGITMAP, REGIAO.NMREGIAO, ITMAPURPREC.NRCOLEITMAP, ITMAPURPREC.CDPRODITMAP, PRODUTO.CDPRODESTO, PRODUTO.CDARVPROD, PRODUTO.NMPRODUTO, ITMAPURPREC.CDMARCITMAP, MARCA.NMMARCA, ITMAPURPREC.VRPRECUNIAP, ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP, DECODE (PARASUPRI.IDTIPOAPUR, NULL, ITMAPURPREC.VRPRECUNIAP, '1', ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP), FORNECEDOR.SGUNIDADE, NVL(MINFORNREG.QTMINFORNREG, FORNECEDOR.QTMINAUTFOT), DECODE(MINFORNREG.QTMINFORNREG, NULL, 'F', 'R'), NVL(MINFORNREG.VRMINFORNREG, FORNECEDOR.VRMINAUTFOR), DECODE(MINFORNREG.VRMINFORNREG, NULL, 'F', 'R'), PRODUTO.VRFATOCONV, CEIL(NVL(ESTOSEGU.QTESTOSEGU, 0) /PRODUTO.VRFATOCONV), CEIL(NVL(ESTOSEGU.QTESTOSEGU - CALC_ESTOQ_CONS(:P_CDFILIOPELOG, RELACPRODOL.CDPRODARVOL, SYSDATE + 1), 0)/PRODUTO.VRFATOCONV) ORDER BY QTACOMP, DECODE (PARASUPRI.IDTIPOAPUR, NULL, ITMAPURPREC.VRPRECUNIAP, '1', ITMAPURPREC.VRPRECECOAP, ITMAPURPREC.VRPRECONPIAP)";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function adqNrlogcorteol($params) {
        $sql = "SELECT NRLOGCORTEOL, CDFILCENTCMP FROM APURPRECO WHERE (APURPRECO.CDFILCENTCMP = :P_CDCENTCMP) AND (APURPRECO.NRAPURPREC = :P_NRSEQAPUR) AND NRLOGCORTEOL IS NOT NULL";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }

    public function executeEFETIVAR_AF($params) {
        try {
            $procedure = new StoredProcedure($this->connection, 'EFETIVAR_AF');
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $params['P_CDOPERADOR'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTAUTOFORN', Param::PARAM_INPUT, $params['P_DTAUTOFORN'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCENTCMP',  Param::PARAM_INPUT, $params['P_CDCENTCMP'],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSEQAPUR',  Param::PARAM_INPUT, $params['P_NRSEQAPUR'],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILLANC',  Param::PARAM_INPUT, $params['P_CDFILLANC'],  Param::PARAM_TYPE_STR));
            $procedure->execute();
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function adqEmpenhaAf($params) {
        $sql = "SELECT A.IDUTEMPENHAF FROM (SELECT NVL(MAX(IDUTEMPENHAF), 'N') AS IDUTEMPENHAF FROM PARASUPRI WHERE CDFILIAL = :P_CDFILCENTCMP) A";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    } 
    
    public function executeEMPENHAR_AF($params) {
        $procedure = new StoredProcedure($this->connection, 'EMPENHAR_AF');
        $procedure->addParam(new Param('P_NRSEQAPUR',    Param::PARAM_INPUT, $params['P_NRSEQAPUR'],    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILLANC',    Param::PARAM_INPUT, $params['P_CDFILLANC'],    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILCENTCMP', Param::PARAM_INPUT, $params['P_CDFILCENTCMP'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $params['P_CDOPERADOR'],   Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
    public function adqEfetivaAF($params) {
        $sql = "SELECT NRSEQAPUR FROM EFETIVAAF WHERE CDOPERADOR = :P_CDCOMPRADOR AND DTAUTOFORN = TRUNC(SYSDATE) AND CDCENTCMP = :P_CDCENTCMP AND NRSEQAPUR = :P_NRSEQAPUR AND CDFILLANC = :P_CDFILLANC AND CDOPERALANC = :P_CDOPERALANC";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function adqAutoForne($params) {
        $sql = "SELECT AUT.CDFILDEST, AUT.CDFILLANC, AUT.NRAUTOFORN, AUT.CDEMPRESA, AUT.IDTPIJURTRAN, AUT.NRINSJURTRAN, AUT.CDOPERADOR, AUT.CDFORNECED, AUT.CDTIPCOB, AUT.DTAUTOFORN, AUT.VRTOTALAF, AUT.IDTIPOEMITAF, AUT.IDSITUATUAAF, AUT.IDIMAUTOFORN, AUT.IDTIPOFRETAF, AUT.IDAUTOFORNEX, AUT.IDTIPOLANCAF, AUT.IDAFFORALIM, AUT.IDBAIXAAF, AUT.CDFORMPGTO, AUT.IDTPFORPGTAF, AUT.NRPARCPGTOAF, AUT.NRDIAPGFIXAF, AUT.IDUTDIAPGTAF, FORN.NMFANTFORN, FORN.DSEMAILCOT, FIL.NMFILIAL, AUT.IDAFPRODWEB, AUT.IDAFOPERLOG, '0' AS IDERRO FROM AUTOFORNE AUT, FORNECEDOR FORN, FILIAL FIL WHERE (CDFILLANC = :P_CDFILLANC) AND (NRSEQAPURAF = :P_NRSEQAPURAF) AND (AUT.CDFORNECED = FORN.CDFORNECED) AND (AUT.CDFILDEST = FIL.CDFILIAL)";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function executeCUSTO_AF($params) {
        $procedure = new StoredProcedure($this->connection, 'CUSTO_AF');
        $procedure->addParam(new Param('P_CDFILDEST',   Param::PARAM_INPUT, $params['P_CDFILDEST'],   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILLANC',   Param::PARAM_INPUT, $params['P_CDFILLANC'],   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAUTOFORN',  Param::PARAM_INPUT, $params['P_NRAUTOFORN'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQAPURAF', Param::PARAM_INPUT, $params['P_NRSEQAPURAF'], Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
    public function adqInconsAF($params) {
        $sql = "SELECT CDFILDEST, CDFILLANC, NRAUTOFORN, CDOPERADOR, CDFORNECED FROM AUTOFORNE WHERE NRSEQAPURAF = :P_NRAPURPRECO AND CDFILLANC = :P_CDFILLANC";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function adqCot_ItemAutF($params) {
        $sql = "SELECT QTPROGENTAF, CDFILIAL, NRCOLEPRECO, CDMARCA, CDREGIAO, CDFORNECED, CDPRODUTO FROM (SELECT SUM(QTPROGENTAF) AS QTPROGENTAF, CDFILCOTITAF AS CDFILIAL, NRCOTPREITAF AS NRCOLEPRECO, CDMARCOTITAF AS CDMARCA, CDREGCOTITAF AS CDREGIAO, CDFORCOTITAF AS CDFORNECED, CDPROCOTITAF AS CDPRODUTO FROM ITEMAUTF WHERE ITEMAUTF.CDFILDEST = :P_CDFILDEST AND ITEMAUTF.CDFILLANC = :P_CDFILLANC AND ITEMAUTF.NRAUTOFORN = :P_NRAUTOFORN GROUP BY CDFILCOTITAF, NRCOTPREITAF, CDMARCOTITAF, CDREGCOTITAF, CDFORCOTITAF, CDPROCOTITAF) A";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function adqPedCol($params) {
        $sql = "SELECT CDFILIAL, NRPEDIDOCOL FROM ITEMCOLE WHERE CDFILIAL = :P_CDFILIAL AND NRCOLEPRECO = :P_NRCOLEPRECO AND CDMARCA = :P_CDMARCA AND CDREGIAO = :P_CDREGIAO AND CDFORNECED = :P_CDFORNECED AND CDPRODUTO = :P_CDPRODUTO";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function acmUpdPrMarcPedCol($params) {
        $sql = "UPDATE PRMARCPEDCOL SET QTDISPPRODMARC = QTDISPPRODMARC + :P_QTDEAF WHERE CDFILIAL = :P_CDFILIAL AND NRPEDIDOCOL = :P_NRPEDIDOCOL AND CDPRODUTO = :P_CDPRODUTO AND CDMARCA = :P_CDMARCA";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
    }
    
    public function acmExcluiAF($params) {
        $sql = "DELETE FROM AUTOFORNE WHERE CDFILLANC = :P_CDFILLANC AND NRSEQAPURAF = :P_NRSEQAPURAF";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
    }
    
    public function adqVd_EfetivaAF($params) {
        $sql = "SELECT NRSEQAPUR FROM EFETIVAAF WHERE CDOPERADOR = :P_CDCOMPRADOR AND DTAUTOFORN = TRUNC(SYSDATE) AND CDCENTCMP = :P_CDCENTCMP AND NRSEQAPUR = :P_NRSEQAPUR AND CDFILLANC = :P_CDFILLANC AND CDOPERALANC = :P_CDOPERALANC";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function acmInsEfetivaAF($params) {
        $sql = "INSERT INTO EFETIVAAF (CDOPERADOR, DTAUTOFORN, CDCENTCMP, NRSEQAPUR, CDFILLANC, CDOPERALANC, DTOPERACAO) VALUES (:P_CDCOMPRADOR, TRUNC(SYSDATE), :P_CDCENTCMP, :P_NRSEQAPUR, :P_CDFILLANC, :P_CDOPERALANC, SYSDATE)";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
    }
    
    public function adqParamCmp($param) {
        $sql = "SELECT CDFILIAL , IDJUSSOLEXT , IDBLOQALTNEC, IDAUDALTSOL, IDULTIDTULTI, IDULTCOMPSOL, IDULTDESTSOL, CDGRUPOPER , IDULTIDTVALQ, IDVALDTAF , IDBLOQUEAAF , IDMARSEMQUA, IDTIPOAPUR, IDPROSEMMAR, IDPROSEMFOR , IDUTQTDEVOLU, IDBAIXSOLDFS, IDCONSPRSOL, IDEXJUSTESCM , IDBLOQALTSOLAUT, NRORG FROM PARASUPRI WHERE INSTR(:CDFILIAL, CDFILIAL) > 0";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($param);
        return $stmt->fetchAll();
    }
    
    public function adqBloqAF($params) {
        $sql = "SELECT NVL(IDBLOQUEAAF, 'N') IDBLOQUEAAF FROM PARASUPRI, FILIAL WHERE PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AND FILIAL.CDFILIAL = :P_CDFILDEST";
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
        return $stmt->fetchAll();
    }
    
    public function proceFechamentoAF($params) {
        $procedure = new StoredProcedure($this->connection, 'FECHAMENTO_AF');
        
        $procedure->addParam(new Param('P_CDFILDEST', Param::PARAM_INPUT, $params['P_CDFILDEST'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILLANC', Param::PARAM_INPUT, $params['P_CDFILLANC'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAUTOFORN', Param::PARAM_INPUT, $params['P_NRAUTOFORN'], Param::PARAM_TYPE_STR));
        
        $procedure->execute();
        
    }
}
