<?php
namespace Teknisa\OPL\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Resquest;
use Zeedhi\Framework\DTO\Resquest\Filter;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Row;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Exception;

class Sup09500ComparativoEntreCustosController extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $dataSourceName;
    
    public function __construct($crudService, $parameterBag) {
        parent::__construct($crudService, $parameterBag);
    }
    
    //This function gets and manage the data of the main query 
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'paramprodsup_produto_filial_regiao';
        $rowItems = $this->getItemsData($request,$response);
        
        $resultDataSet = [];
        $this->dataSourceName = 'itemcole_fornecedor_produto_marca_coletar';
        
        //This loop will mount main dataSet with formated and calculated fields
        foreach($rowItems as $rowItem){
            $rowCotacoes = $this->getCotacaoData($request,$rowItem);
            if($rowCotacoes){
                foreach($rowCotacoes as $rowCotacao){
                    $row = $rowItem;
                    
                    $row['NRCOLEPRECOED'] = $rowCotacao['NRCOLEPRECO'] ?? '';     
                    $row['NMFANTFORNED'] = $rowCotacao['NMFANTFORN'] ?? '';
                    $row['VRPRECUNIITMED'] = $rowCotacao['VRPRECUNIITM'] ?? '';
                    $row['TOTALED'] = ($row['QTACOMPRAR'] * $row['VRFATOCONV']) * $rowCotacao['VRPRECUNIITM'] ?? 0;
                    $row['TOTALOL'] = ($row['QTACOMPRAR'] * $row['VRFATOCONV']) * $row['VRCUSTO'];
                    $row['AGRUPUNIDADE'] = $row['CDFILIAL'] ." - ". $row['NMFILIAL'];
                    
                    $embaledString = $rowCotacao['VRFATOCONV']." ".$row['SGUNIDADE']." ".$rowCotacao['NMMARCA'];
                    $row['EMBALED'] = $rowCotacao['VRFATOCONV'] > 0 ? $embaledString : '';
                    
                    $resultDataSet[] = $row;
                }
            }
        }
        $response->setDataSets([new DataSet("getReportData", $resultDataSet)]);
    }
    
    //it gets items data
    public function getItemsData($request,$response){
        $conditions = $request->getFilterCriteria()->getConditions();
        
        $InArrayParams = [
            'CDCOMPRADOR',
            'CDFORNECED',
            'NMRELATORIO',
            'DTCONTAGEM'
        ];
        
        foreach($conditions as $key=>$condition){
            if(in_array($condition['columnName'],$InArrayParams)){
                unset($conditions[$key]);
            }
        }
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, $conditions);
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        parent::find($filter,$response);
        
        return $response->getDataSets()[0]->getRows();
        
    }
    
    //it gets price data
    public function getCotacaoData($request,$rowItem){
        $conditions = $request->getFilterCriteria()->getConditions();
        
        $conditions = array_filter($conditions ,function($condition){
            return $condition['columnName'] == 'CDCOMPRADOR' || $condition['columnName'] == 'CDFORNECED';
        });
        
        $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
        $filterCriteria->addCondition('CDREGIAO', $rowItem['CDREGIAO']);
        $filterCriteria->addCondition('DTPROGENTR', substr($rowItem['DTPROGENTR'],0,10)); 
        $filterCriteria->addCondition('CDPRODESTO', $rowItem['CDPRODESTO']);

        $filter = new DTO\Request\Filter($filterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $newResponse = new Response();
        parent::find($filter,$newResponse);
        return $newResponse->getDataSets()[0]->getRows();
    }
    
}