function EmissaoPedidosOLController(ScreenService, templateManager, ZhFilterPreferences, MessageService, maskEngine, ZhUtil, General, emissao_de_pedidos_Service) { 
    var parametrosParaSupri;
    var parametrosGerais;
    var parametrosParCmpsup;
    var ServiceEmissaoPedidoOL = emissao_de_pedidos_Service;
    var self = this;
    var opEmissao;
    var CDFILIOPELOGPROD;
    var permissoesGeraisOperador;
    var permissoesFinaisOperador;
    
    this.onEnterOnceWidgetPedidos = function(args) {
        const widget = args.owner;
        const rowsToSet = {};
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        var resp;
        
        widgetDadosPedido.enabled = false;
        widgetDetalhesPedido.enabled = false;
        
        ScreenService.showLoader();
        
        rowsToSet.defaultFilter = widget.dataSourceFilter;
        rowsToSet.TCDLOTENVITOL = 'N';
        rowsToSet.IDBAIXAAF = [ '0', '1', '2', '3', '4', '5' ];
        rowsToSet.PEDOLEXTR = [ 'S', 'N' ];
        rowsToSet.TRESERVA = [ 'S', 'N' ];
        
        General.callRestEngine("opl#/crud/parcmpsup", "FilterData", [
            {
        		"name": "CDFILIAL",
        		"operator": "=",
        		"value": "FILIAL_LOGADA"
        	}
        ]).then(function(response) {
            parametrosParCmpsup = response.dataset.parcmpsup[0];
        }).catch(function(error) {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
        
        General.callRestEngine("opl_relatorios#/permissoesGrupoOperador", "Row", {}).then(function(response) {
            permissoesGeraisOperador = response.dataset.permissoesGeraisOperador.map(function(row) {
                return row.IDAUTGRUPOP;
            }).join("_");
            permissoesFinaisOperador = Util.isEmptyOrBlank(response.dataset.permissoesFinaisOperador) ? "" : response.dataset.permissoesFinaisOperador.map(function(row) {
                return row.IDAUTGRUPOP;
            }).join("_");
        }).catch(function(error) {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
        
        General.callRestEngine("opl_relatorios#/getCentralCompras", "Row", {}).then(function(response) {
            resp = response.dataset.data;
                
            if(resp) {
                if(resp.CDFILIAL == resp.CDFILCENTCMP) {
                    rowsToSet.NMFILIAL = [ resp.CDFILCENTCMP ];
                    
                    widget.currentRow.NMFILIAL = [ resp.CDFILCENTCMP ];
                } else {
                    rowsToSet.NMFILIAL = [ resp.CDFILIAL ];
                    
                    widget.currentRow.NMFILIAL = [ resp.CDFILIAL ];
                }
            }
            
            widget.getField("NMFILIAL").reload().then(function(resposta) {
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
                    const filterWidget = templateManager.container.getActiveWidget();
                    const excluirReserva = widget.getAction("excluirReserva");
                    const incluirReserva = widget.getAction("incluirReserva");
                    const bloquearItemPedido = widget.getAction("bloquearItemPedido");
                    const desbloquearItemPedido = widget.getAction("desbloquearItemPedido");
                    const filter = [
                        {
        					"name": "CDFILIAL",
        					"operator": "=",
        					"value": resp.CDFILIAL
        				},
        				{
        					"name": "NRORG",
        					"operator": "=",
        					"value": resp.NRORG
        				}
        			];
        			
        			if(resp) {
        			    if(resp.CDFILIAL == resp.CDFILCENTCMP)
                            filterWidget.getField("NMFILIAL").readOnly = false;
                        else
                            filterWidget.getField("NMFILIAL").readOnly = true;
        			}
        			
        			bloquearItemPedido.isVisible = true;
        			desbloquearItemPedido.isVisible = true;
        			
                    filterWidget.getField("NMFILIAL").reload();
                    
                    filterWidget.activate();
        			
                    ScreenService.hideLoader();
                    
                    General.callRestEngine("opl#/crud/paramgeral", "FilterData", []).then(function(response) {
                        parametrosGerais = response.dataset.paramgeral[0];
                        
                        General.callRestEngine("opl#/crud/parasupri", "FilterData", filter).then(function(response) {
                            parametrosParaSupri = response.dataset.parasupri[0];
                            
                            if(parametrosParaSupri && parametrosParaSupri.IDUTRESPEDEXOL === 'S') {
                                excluirReserva.isVisible = true;
                                incluirReserva.isVisible = true;
                            } else {
                                excluirReserva.isVisible = false;
                                incluirReserva.isVisible = false;
                            }
                            
                            if(parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
                                widget.getField("DSINCONITMOLEXP").isVisible = true;
                            } else {
                                widget.getField("DSINCONITMOLEXP").isVisible = false;
                            }
                            var boHabilita;
                            boHabilita = false;
                            if(permissoesGeraisOperador.indexOf("BLOL") == -1) {
                                boHabilita =  false;
                            } else {
                                if(permissoesFinaisOperador.indexOf("BLOL") != -1) {
                                    boHabilita = true;    
                                } else {
                                    boHabilita = false;
                                }
                            }
                            bloquearItemPedido.isVisible   = boHabilita;
                            desbloquearItemPedido.isVisible = boHabilita;    
                        }).catch(function(error) {
                            excluirReserva.isVisible = false;
                            incluirReserva.isVisible = false;
                            
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        });
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                    
                }).catch(error => {
                    ScreenService.hideLoader();
                });
            });
        }).catch(function(error) {
            if(error.data.error == "CDFILCENTCMP_NOT_REGISTERED") {
                MessageService.showMessageByCode(error.data.error);
            } else {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            }
        });
    };
    
    this.changeFieldsRegiaoRotaUnidade = function(widget) {
        const fieldRegiao = widget.getField("CDREGIAO");
        const fieldRota = widget.getField("CDROTATRANS");
        const fieldUnidade = widget.getField("NMFILIAL");
        
        widget.currentRow.CDREGIAO = null;
        widget.currentRow.CDROTATRANS = null;
        widget.currentRow.CDFILIAL = null;
        widget.currentRow.NMFILIAL = null;
        
        fieldRegiao.clearValue();
        fieldRegiao.reload();
        
        fieldRota.clearValue();
        fieldRota.reload();
        
        fieldUnidade.clearValue();
        fieldUnidade.reload();
        fieldUnidade.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": "@getLocalVar('CDOPERADOR')@"
            },
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": "T"
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": ""
            },
            {
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "P_CDROTA",
                "operator": "=",
                "value": "T"
            }
        ];
        fieldUnidade.reload();
        
        widget.activate();
    };
    
    this.changeFieldsRotaUnidade = function(widget) {
        const fieldRota = widget.getField("CDROTATRANS");
        const fieldUnidade = widget.getField("NMFILIAL");
        
        widget.currentRow.CDROTATRANS = null;
        widget.currentRow.CDFILIAL = null;
        widget.currentRow.NMFILIAL = null;
        
        fieldRota.clearValue();
        fieldRota.reload();
        
        fieldUnidade.clearValue();
        fieldUnidade.reload();
        fieldUnidade.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": "@getLocalVar('CDOPERADOR')@"
            },
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? "" : 'T' : 'T'
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? widget.currentRow.CDREGIAO.join('_') : "" : ""
            },
            {
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "P_CDROTA",
                "operator": "=",
                "value": "T"
            }
        ];
        fieldUnidade.reload();
        
        widget.activate();
    };
    
    this.changeFieldsUnidade = function(widget) {
        const fieldUnidade = widget.getField("NMFILIAL");
        
        widget.currentRow.CDFILIAL = null;
        widget.currentRow.NMFILIAL = null;
        
        fieldUnidade.clearValue();
        fieldUnidade.reload();
        fieldUnidade.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": "@getLocalVar('CDOPERADOR')@"
            },
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? "" : 'T' : 'T'
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? widget.currentRow.CDREGIAO.join('_') : "" : ""
            },
            {
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "P_CDROTA",
                "operator": "=",
                "value": widget.currentRow.CDROTATRANS ? (widget.currentRow.CDROTATRANS.length > 0) ? widget.currentRow.CDROTATRANS.join('_') : 'T' : 'T'
            }
        ];
        fieldUnidade.reload();
        
        widget.activate();
    };
    
    this.changeFieldLote = function(widget) {
        const fieldlote = widget.getField("CDLOTE");
        
        if(widget.currentRow.TCDLOTENVITOL === 'L') {
            fieldlote.readOnly = false;
            fieldlote.validations = {
                "required": true
            };
            fieldlote.reload();
            fieldlote.setValue(null);
            widget.redraw();
        } else {
            fieldlote.readOnly = true;
            fieldlote.reload();
            fieldlote.setValue(null);
            delete fieldlote.validations;
            widget.redraw();
        }
        
        widget.activate();
        widget.sync();
    };
    
    this.changeFieldSubgrupo = function(widget) {
        const fieldSubgrupo = widget.getField("CDSUBGRPROD");
        
        if(widget.currentRow.NCONSIDERASUBGRUPO === 'N') {
            fieldSubgrupo.readOnly = false;
            fieldSubgrupo.reload();
            fieldSubgrupo.setValue(null);
        } else {
            fieldSubgrupo.readOnly = true;
            fieldSubgrupo.reload();
            fieldSubgrupo.setValue(null);
        }
        
        widget.activate();
    };
    
    this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = row.CDPRODINI ? true : false;
		
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
		}
        this.checkProductRange(args.owner.field);
	};
	
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = row.CDPRODFIN ? true : false;
		var prodIniIsSet = row.CDPRODINI ? true : false;
		
		if (prodFinIsSet) {
			if (row.CDPRODINI > row.CDPRODFIN) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		} else if(!prodIniIsSet) {
            widget.currentRow.NMPRODFIN = null;
            widget.currentRow.CDPRODFIN = null;
		}
		
		this.checkProductRange(args.owner.field);
	};
	
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;

		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;

                field.widget.getField('NMPRODINI').clearValue();
                field.widget.getField('NMPRODFIN').clearValue();
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		}
	};
	
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    this.changeFieldBlock = function(widget) {
        const fieldBlock = widget.getField("DTBLOQ");
        
        if(widget.currentRow.TDTBLOQ === 'S') {
            fieldBlock.readOnly = false;
            fieldBlock.clearValue();
        } else {
            fieldBlock.readOnly = true;
            fieldBlock.clearValue();
        }
        
        widget.currentRow.DTBLOQ = {
            "start": "",
            "end": "",
            "formattedStart": "__/__/____",
            "formattedEnd": "__/__/____"
        };
        
        widget.activate();
    };
    
    this.changeFieldUnblock = function(widget) {
        const fieldUnblock = widget.getField("DTNBLOQ");
        
        if(widget.currentRow.TDTNBLOQ === 'S') {
            fieldUnblock.readOnly = false;
            fieldUnblock.clearValue();
        } else {
            fieldUnblock.readOnly = true;
            fieldUnblock.clearValue();
        }
        
        widget.currentRow.DTNBLOQ = {
            "start": "",
            "end": "",
            "formattedStart": "__/__/____",
            "formattedEnd": "__/__/____"
        };
        
        widget.activate();
    };
    
    this.setDataSourceFilter = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        const parametrosFinais = {
            "P_CDGRUPFILI": filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : null,
            "P_CDREGIAO": (!filterRow.CDREGIAO || filterRow.CDREGIAO.length == 0) ? null : '_' + filterRow.CDREGIAO.join('_') + '_',
            "P_TCDREGIAO": (!filterRow.CDREGIAO || filterRow.CDREGIAO.length == 0) ? 'T' : null,
            "P_CDFILIOPELOG": (!filterRow.NMFILIALOL || filterRow.NMFILIALOL.length == 0) ? null : '_' + filterRow.NMFILIALOL.join('_') + '_',
            "P_TCDFILIOPELOG": (!filterRow.NMFILIALOL || filterRow.NMFILIALOL.length == 0) ? 'T' : null,
            "P_CDFILIAL": (!filterRow.NMFILIAL || filterRow.NMFILIAL.length == 0) ? null : '_' + filterRow.NMFILIAL.join('_') + '_',
            "P_TCDFILIAL": (!filterRow.NMFILIAL || filterRow.NMFILIAL.length == 0) ? 'T' : null,
            "P_DTPEDINI": filterRow.DTPEDEXOL.start ? filterRow.DTPEDEXOL.start : null,
            "P_DTPEDFIN": filterRow.DTPEDEXOL.end ? filterRow.DTPEDEXOL.end : null,
            "P_DTEMBINI": filterRow.DTPROGEMBARQ.start ? filterRow.DTPROGEMBARQ.start : null,
            "P_DTEMBFIN": filterRow.DTPROGEMBARQ.end ? filterRow.DTPROGEMBARQ.end : null,
            "P_DTENTINI": filterRow.DTPROGENPEOL.start ? filterRow.DTPROGENPEOL.start : null,
            "P_DTENTFIN": filterRow.DTPROGENPEOL.end ? filterRow.DTPROGENPEOL.end : null,
            "P_CDPRODINI": filterRow.CDPRODINI ? filterRow.CDPRODINI : null,
            "P_CDPRODFIN": filterRow.CDPRODFIN ? (filterRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20) : null,
            "P_CDOPERADOR": getLocalVar('CDOPERADOR'),
            "P_DTBLOQINI": filterRow.TDTBLOQ === 'S' ? filterRow.DTBLOQ.start ? filterRow.DTBLOQ.start : null : null,
            "P_DTBLOQFIN": filterRow.TDTBLOQ === 'S' ? filterRow.DTBLOQ.end ? filterRow.DTBLOQ.end : null : null,
            "P_TBLOQ": (filterRow.TDTBLOQ === 'S' && !Util.isEmptyOrBlank(filterRow.DTBLOQ.start) && !Util.isEmptyOrBlank(filterRow.DTBLOQ.end)) ? null : filterRow.TDTBLOQ === 'S' ? 'T' : null,
            "P_BLOQ": filterRow.TDTBLOQ === 'S' ? 'S' : 'N',
            "P_DTNBLOQINI": filterRow.TDTNBLOQ === 'S' ? filterRow.DTNBLOQ.start ? filterRow.DTNBLOQ.start : null : null,
            "P_DTNBLOQFIN": filterRow.TDTNBLOQ === 'S' ? filterRow.DTNBLOQ.end ? filterRow.DTNBLOQ.end : null : null,
            "P_TNBLOQ": (filterRow.TDTNBLOQ === 'S' && !Util.isEmptyOrBlank(filterRow.DTNBLOQ.start) && !Util.isEmptyOrBlank(filterRow.DTNBLOQ.end)) ? null : filterRow.TDTNBLOQ === 'S' ? 'T' : null,
            "P_NBLOQ": filterRow.TDTNBLOQ === 'S' ? 'N' : 'S',
            "P_PEDOLEXTR": filterRow.PEDOLEXTR.length == 2 ? 'T' : filterRow.PEDOLEXTR[0] === 'S' ? 'S' : 'N',
            "P_CDLOTENVIOL": filterRow.TCDLOTENVITOL === 'N' ? 'T' : filterRow.TCDLOTENVITOL == 'S' ? 'S' : (!filterRow.CDLOTE || filterRow.CDLOTE.length == 0) ? 'T' : '_' + filterRow.CDLOTE.join('_') + '_',
            "P_TRESERVA": filterRow.TRESERVA.length == 2 ? '1' : filterRow.TRESERVA[0] === 'S' ? '2' : '3',
            "P_SUBGRUPO": filterRow.NCONSIDERASUBGRUPO === 'S' ? 'N' : (!filterRow.CDSUBGRPROD || filterRow.CDSUBGRPROD.length == 0) ? 'N' : '_' + filterRow.CDSUBGRPROD.join('_') + '_',
            "P_CDGRUPPROD": filterRow.NCONSIDERASUBGRUPO === 'S' ? null : (!filterRow.CDGRUPPROD || filterRow.CDGRUPPROD.length == 0) ? null : filterRow.CDGRUPPROD[0],
            "P_CDROTA": (!filterRow.CDROTATRANS || filterRow.CDROTATRANS.length == 0) ? 'T' : '_' + filterRow.CDROTATRANS.join('_') + '_',
            "P_IDBAIXAAF": (!filterRow.IDBAIXAAF || filterRow.IDBAIXAAF.length == 0) ? null : filterRow.IDBAIXAAF.length == 1 ? filterRow.IDBAIXAAF[0] :  '_' + filterRow.IDBAIXAAF.join('_') + '_'
        };
        const adicionaItemPedidoAction = widget.getAction("adicionaItemPedido");
        const adicionaNovoPedidoAction = widget.getAction("adicionaNovoPedido");
        
        if(parametrosFinais.P_TRESERVA == 3) {
            widget.getField("QTRESERVESTOL").isVisible = false;
        } else {
            widget.getField("QTRESERVESTOL").isVisible = true;
        }
        
        CDFILIOPELOGPROD = parametrosFinais.P_CDFILIOPELOG.substr(1, 4);
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDGRUPFILI",
		        "operator": "=",
		        "value": parametrosFinais.P_CDGRUPFILI
		    },
		    {
		        "name": "P_CDREGIAO",
		        "operator": "=",
		        "value": parametrosFinais.P_CDREGIAO
		    },
		    {
		        "name": "P_TCDREGIAO",
		        "operator": "=",
		        "value": parametrosFinais.P_TCDREGIAO
		    },
		    {
		        "name": "P_CDFILIOPELOG",
		        "operator": "=",
		        "value": parametrosFinais.P_CDFILIOPELOG
		    },
		    {
		        "name": "P_TCDFILIOPELOG",
		        "operator": "=",
		        "value": parametrosFinais.P_TCDFILIOPELOG
		    },
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": parametrosFinais.P_CDFILIAL
		    },
		    {
		        "name": "P_TCDFILIAL",
		        "operator": "=",
		        "value": parametrosFinais.P_TCDFILIAL
		    },
		    {
		        "name": "P_DTPEDINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTPEDINI
		    },
		    {
		        "name": "P_DTPEDFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTPEDFIN
		    },
		    {
		        "name": "P_DTEMBINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTEMBINI
		    },
		    {
		        "name": "P_DTEMBFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTEMBFIN
		    },
		    {
		        "name": "P_DTENTINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTENTINI
		    },
		    {
		        "name": "P_DTENTFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTENTFIN
		    },
		    {
		        "name": "P_CDPRODINI",
		        "operator": "=",
		        "value": parametrosFinais.P_CDPRODINI
		    },
		    {
		        "name": "P_CDPRODFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_CDPRODFIN
		    },
		    {
		        "name": "P_CDOPERADOR",
		        "operator": "=",
		        "value": parametrosFinais.P_CDOPERADOR
		    },
		    {
		        "name": "P_DTBLOQINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTBLOQINI
		    },
		    {
		        "name": "P_DTBLOQFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTBLOQFIN
		    },
		    {
		        "name": "P_TBLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_TBLOQ
		    },
		    {
		        "name": "P_BLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_BLOQ
		    },
		    {
		        "name": "P_DTNBLOQINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTNBLOQINI
		    },
		    {
		        "name": "P_DTNBLOQFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTNBLOQFIN
		    },
		    {
		        "name": "P_TNBLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_TNBLOQ
		    },
		    {
		        "name": "P_NBLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_NBLOQ
		    },
		    {
		        "name": "P_PEDOLEXTR",
		        "operator": "=",
		        "value": parametrosFinais.P_PEDOLEXTR
		    },
		    {
		        "name": "P_CDLOTENVIOL",
		        "operator": "=",
		        "value": parametrosFinais.P_CDLOTENVIOL
		    },
		    {
		        "name": "P_TRESERVA",
		        "operator": "=",
		        "value": parametrosFinais.P_TRESERVA
		    },
		    {
		        "name": "P_SUBGRUPO",
		        "operator": "=",
		        "value": parametrosFinais.P_SUBGRUPO
		    },
		    {
		        "name": "P_CDGRUPPROD",
		        "operator": "=",
		        "value": parametrosFinais.P_CDGRUPPROD
		    },
		    {
		        "name": "P_CDROTA",
		        "operator": "=",
		        "value": parametrosFinais.P_CDROTA
		    },
		    {
		        "name": "P_IDBAIXAAF",
		        "operator": "=",
		        "value": parametrosFinais.P_IDBAIXAAF
		    }
		];
		
		widget.reload().then(function(callback) {
            widget.activate();
            
            if(callback.dataset.sup07200_lancamento_de_pedidos_grid.length == 0) {
                adicionaItemPedidoAction.isVisible = false;
                adicionaNovoPedidoAction.isVisible = true;
            } else {
                adicionaItemPedidoAction.isVisible = true;
                adicionaNovoPedidoAction.isVisible = false;
            }
		});
    };
    
    this.widgetAfterMoveRow = function(args) {
        const widgetItensPedido = args.owner;
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetStripe = templateManager.container.getWidget("stripeWidget");
        
        ScreenService.showLoader();
        
        if(widgetItensPedido.currentRow.NRPEDEXOL) {
            if(widgetItensPedido.mode === "inline_edit") {
                widgetDadosPedido.enabled = false;
                widgetDetalhesPedido.enabled = false;
            } else {
                widgetDadosPedido.enabled = true;
                widgetDetalhesPedido.enabled = true;
            }
            
            widgetDetalhesPedido.dataSourceFilter = [
                {
                    "name": "P_CDPRODUTO",
                    "operator": "=",
                    "value": widgetItensPedido.currentRow.CDARVPROD
                },
                {
                    "name": "P_CDMARCA",
                    "operator": "=",
                    "value": widgetItensPedido.currentRow.CDMARCA
                },
                {
    		        "name": "P_CDFILLANC",
    		        "operator": "=",
    		        "value": widgetItensPedido.currentRow.CDFILLANC
    		    },
    		    {
    		        "name": "P_DTPROGENPEOL",
    		        "operator": "=",
    		        "value": moment(widgetItensPedido.currentRow.DTPROGENPEOL, 'L').format('L')
    		    },
    		    {
    		        "name": "P_CDFILDEST",
    		        "operator": "=",
    		        "value": widgetItensPedido.currentRow.CDFILDEST.split(" - ")[0]
    		    },
    		    {
    		        "name": "P_NRPEDEXOL",
    		        "operator": "=",
    		        "value": widgetItensPedido.currentRow.NRPEDEXOL
    		    }
            ];
            
            widgetDetalhesPedido.reload();
            
            widgetStripe.currentRow.NRPEDEXOL = widgetItensPedido.currentRow.NRPEDEXOL;
            widgetStripe.currentRow.CDFILLANC = widgetItensPedido.currentRow.CDFILLANC;
            widgetStripe.currentRow.IDBAIXENPEOL = widgetStripe.getField("IDBAIXENPEOL").options[widgetItensPedido.currentRow.IDBAIXENPEOL];
            widgetStripe.currentRow.IDBAIXEXSAI = widgetStripe.getField("IDBAIXEXSAI").options[widgetItensPedido.currentRow.IDBAIXEXSAI];
            widgetStripe.currentRow.QTEFETENPEOL = widgetItensPedido.currentRow.QTEFETENPEOL == null ? '0,000' : widgetItensPedido.currentRow.QTEFETENPEOL + ',000';
            widgetStripe.currentRow.IDBAIXEXOL = widgetStripe.getField("IDBAIXEXOL").options[widgetItensPedido.currentRow.IDBAIXEXOL];
            widgetStripe.currentRow.DTPEDEXOL = moment(widgetItensPedido.currentRow.DTPEDEXOL, 'L').format('L');
            widgetStripe.currentRow.IDTIPOEXOL = widgetStripe.getField("IDTIPOEXOL").options[widgetItensPedido.currentRow.IDTIPOEXOL];
            widgetStripe.currentRow.IDITMPEDOLBLOQ = widgetStripe.getField("IDITMPEDOLBLOQ").options[widgetItensPedido.currentRow.IDITMPEDOLBLOQ];
            widgetStripe.currentRow.IDBAIXAOLSAI = widgetStripe.getField("IDBAIXAOLSAI").options[widgetItensPedido.currentRow.IDBAIXAOLSAI];
            
            General.callRestEngine("opl_relatorios#/carregaDadosPedido", "Row", widgetItensPedido.currentRow).then(function(response) {
                const result = response.dataset.opl07200_dados_pedido;
                
                if(result) {
                    widgetDadosPedido.currentRow.NMFILLANC = result.NMFILLANC;
                    widgetDadosPedido.currentRow.CDFILLANC = result.CDFILLANC;
                    widgetDadosPedido.currentRow.NMFILDEST = result.NMFILDEST;
                    widgetDadosPedido.currentRow.CDFILDEST = result.CDFILDEST;
                    widgetDadosPedido.currentRow.NMFILIOPELOG = result.NMFILIOPELOG;
                    widgetDadosPedido.currentRow.CDFILIOPELOG = result.CDFILIOPELOG;
                    widgetDadosPedido.currentRow.DTPEDEXOL = result.DTPEDEXOL;
                    widgetDadosPedido.currentRow.IDPEDEXOLEXTR = result.IDPEDEXOLEXTR;
                    widgetDadosPedido.currentRow.CDEMPRESA = result.CDEMPRESA;
                    widgetDadosPedido.currentRow.IDTIPOEMITAF = result.IDEMITEXOL;
                    widgetDadosPedido.currentRow.NMTIPOEMITAF = result.IDEMITEXOL == '1' ? "Empresa da Unidade" : result.IDEMITEXOL == '2' ? "Empresa Informada" : "Cliente Principal";
                    widgetDadosPedido.currentRow.CDLOTENVITOL = widgetItensPedido.currentRow.CDLOTENVITOL ? widgetItensPedido.currentRow.CDLOTENVITOL : "";
                    widgetDadosPedido.currentRow.CDTIPCOB = result.CDTIPCOB;
                    widgetDadosPedido.currentRow.NMTIPOCOBR = result.NMTIPOCOBR;
                    widgetDadosPedido.currentRow.IDTIPOFRETAF = result.IDTPFRETEXOL;
                    widgetDadosPedido.currentRow.CDTPCTPAGAR = result.CDTPCTPAGAR;
                    widgetDadosPedido.currentRow.DSTPCTPAGAR = result.DSTPCTPAGAR;
                    widgetDadosPedido.currentRow.NRINSJURTRAN = result.NRINSJTREXOL;
                    widgetDadosPedido.currentRow.NMRAZSOCTRAN = result.NMRAZSOCTRAN;
                    widgetDadosPedido.currentRow.IDTPIJURTRAN = result.IDTPJTREXOL;
                    widgetDadosPedido.currentRow.IDBAIXEXOL = result.IDBAIXEXOL;
                    widgetDadosPedido.currentRow.IDBAIXEXSAI = result.IDBAIXEXSAI;
                    widgetDadosPedido.currentRow.NRPEDEXOL = result.NRPEDEXOL;
                    
                    widgetDadosPedido.getField("NMEMPRESA").dataSourceFilter[0].value = result.CDFILDEST;
                    widgetDadosPedido.getField("NMEMPRESA").dataSourceFilter[1].value = result.CDEMPRESA;
                    
                    widgetDadosPedido.getField("NMRAZSOCTRAN").dataSourceFilter[0].value = result.CDFILDEST;
                    widgetDadosPedido.getField("NMRAZSOCTRAN").dataSourceFilter[1].value = "";
                    widgetDadosPedido.getField("NMRAZSOCTRAN").dataSourceFilter[2].value = "";
                    
                    widgetDadosPedido.getField("NMLOTENVITOL").reload().then(data => {
                        let resultLote = data.dataset.lotes_all.filter(function(row) {
                            return row.CDLOTENVITOL == widgetItensPedido.currentRow.CDLOTENVITOL;
                        });
                        widgetDadosPedido.currentRow.NMLOTENVITOL = resultLote.length > 0 ? resultLote[0].NMLOTENVITOL : "";
                        widgetDadosPedido.currentRow.CDLOTENVITOL = resultLote.length > 0 ? resultLote[0].CDLOTENVITOL : "";
                    });
                    
                    self.destinatarioNF(widgetDadosPedido);
                    
                    if(result.IDBAIXEXOL == null || result.IDBAIXEXOL == '0' || result.IDBAIXEXOL == '1') {
                        widgetDadosPedido.getAction("editaDadosPedido").isVisible = true;
                        widgetDadosPedido.getAction("baixaManualPedido").isVisible = true;
                        widgetDadosPedido.getAction("cancelarPedido").isVisible = true;
                        widgetDadosPedido.getAction("encerrarPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("editaDadosPedido").isVisible = false;
                        widgetDadosPedido.getAction("baixaManualPedido").isVisible = false;
                        widgetDadosPedido.getAction("cancelarPedido").isVisible = false;
                        widgetDadosPedido.getAction("encerrarPedido").isVisible = false;
                    }
                    
                    if(result.IDBAIXEXOL == '3' || result.IDBAIXEXOL == '4' || result.IDBAIXEXOL == '5') {
                        widgetDadosPedido.getAction("emAbertoPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("emAbertoPedido").isVisible = false;
                    }
                    
                    if(result.IDBAIXEXOL == null || result.IDBAIXEXOL == '0') {
                        widgetDadosPedido.getAction("excluiPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("excluiPedido").isVisible = false;
                    }
                    
                    if((parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') && (result.IDBAIXEXOL == null || result.IDBAIXEXOL == '0')) {
                        widgetDadosPedido.getAction("exportarPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("exportarPedido").isVisible = false;
                    }
                    
                    ScreenService.hideLoader();
                } else {
                    ScreenService.hideLoader();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": "Não foi possível carregar os dados do pedido." });
                }
            }).catch(function(error) {
                ScreenService.hideLoader();
                
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else {
            widgetDadosPedido.enabled = false;
            widgetDetalhesPedido.enabled = false;
            
            ScreenService.hideLoader();
        }
    };
    
    this.adicionaItemPedido = function(widget) {
        const widgetAdicionaItemPedido = templateManager.container.getWidget("adicionaItemPedido");
        var fieldProduto = widgetAdicionaItemPedido.getField('NMPRODUTO');
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == "P_PRODCMP")
                filtro.value = parametrosParaSupri.IDUTLPROCMP;
            if(filtro.name == "P_CDFILSOLI")
                filtro.value = "FILIAL_LOGADA";
        });
        
        if(widget.currentRow.NRPEDEXOL) {
            widgetAdicionaItemPedido.currentRow.NRPEDEXOL = widget.currentRow.NRPEDEXOL;
            widgetAdicionaItemPedido.currentRow.DTPROGENPEOL = moment(widget.currentRow.DTPROGENPEOL, 'L').format('L');
            widgetAdicionaItemPedido.currentRow.CDMARCA = widget.currentRow.CDMARCA;
            widgetAdicionaItemPedido.currentRow.NMMARCA = widget.currentRow.NMMARCA;
            widgetAdicionaItemPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
            widgetAdicionaItemPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
            widgetAdicionaItemPedido.currentRow.CDFILDEST = widget.currentRow.CDFILDEST.split(' - ')[0];
            widgetAdicionaItemPedido.currentRow.NMFILDEST = widget.currentRow.CDFILDEST.split(' - ')[1];
            widgetAdicionaItemPedido.currentRow.QTPROGENPEOL = widget.currentRow.QTPROGENPEOL;
            widgetAdicionaItemPedido.currentRow.CDFILIOPELOG = widget.currentRow.CDFILIOPELOG;
            
            widgetAdicionaItemPedido.getField("NMFILIOPELOG").reload().then(data => {
                let result = data.dataset.filial_ol.filter(function(row) {
                    return row.CDFILIAL == widget.currentRow.CDFILIOPELOG;
                });
                widgetAdicionaItemPedido.currentRow.NMFILIOPELOG = result[0].NMFILIAL;
            });
            
            widgetAdicionaItemPedido.getField("NRPEDEXOL").readOnly = true;
        } else {
            if(widget.dataSource.data.length > 0) {
                widgetAdicionaItemPedido.currentRow.NRPEDEXOL = widget.dataSource.data[0].NRPEDEXOL;
                widgetAdicionaItemPedido.currentRow.DTPROGENPEOL = moment(widget.dataSource.data[0].DTPROGENPEOL, 'L').format('L');
                widgetAdicionaItemPedido.currentRow.CDMARCA = widget.dataSource.data[0].CDMARCA;
                widgetAdicionaItemPedido.currentRow.NMMARCA = widget.dataSource.data[0].NMMARCA;
                widgetAdicionaItemPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
                widgetAdicionaItemPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
                widgetAdicionaItemPedido.currentRow.CDFILDEST = widget.dataSource.data[0].CDFILDEST.split(' - ')[0];
                widgetAdicionaItemPedido.currentRow.NMFILDEST = widget.dataSource.data[0].CDFILDEST.split(' - ')[1];
                widgetAdicionaItemPedido.currentRow.QTPROGENPEOL = widget.dataSource.data[0].QTPROGENPEOL;
                widgetAdicionaItemPedido.currentRow.CDFILIOPELOG = widget.dataSource.data[0].CDFILIOPELOG;
                
                widgetAdicionaItemPedido.getField("NMFILIOPELOG").reload().then(data => {
                    let result = data.dataset.filial_ol.filter(function(row) {
                        return row.CDFILIAL == widget.dataSource.data[0].CDFILIOPELOG;
                    });
                    widgetAdicionaItemPedido.currentRow.NMFILIOPELOG = result[0].NMFILIAL;
                });
                
                widgetAdicionaItemPedido.getField("NRPEDEXOL").readOnly = true;
            } else {
                widgetAdicionaItemPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
                widgetAdicionaItemPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
                widgetAdicionaItemPedido.currentRow.DTPROGENPEOL = moment().format('L');
                
                widgetAdicionaItemPedido.getField("NRPEDEXOL").readOnly = false;
            }
        }
        
        if(parametrosParaSupri.IDUTILCONSSOLIOLEXT === 'S') {
            widgetAdicionaItemPedido.getField("CDLOTENVITOL").readOnly = true;
            widgetAdicionaItemPedido.getField("CDLOTENVITOL").isVisible = true;
        } else {
            widgetAdicionaItemPedido.getField("CDLOTENVITOL").readOnly = true;
            widgetAdicionaItemPedido.getField("CDLOTENVITOL").isVisible = false;
        }
        
        ScreenService.openSwipe(widgetAdicionaItemPedido);
    };
    
    this.salvaAdicaoItemPedido = function(widget) {
        const dataProc = moment(getLocalVar("DTPROCESSA"), "DD/MM/YYYY").format("MM-DD-YYYY");
        const dataEscd = moment(widget.currentRow.DTPROGENPEOL, "DD/MM/YYYY").format("MM-DD-YYYY");
        
        widget.currentRow.FINAL = permissoesFinaisOperador;
        widget.currentRow.GERAL = permissoesGeraisOperador;
        
        if(widget.isValid()) {
            if(moment(dataEscd).isSameOrAfter(dataProc)) {
                General.callRestEngine("opl_relatorios#/adqRelacProdOL", "Row", widget.currentRow).then(function(resp) {
                    
                    if(Util.isEmptyOrBlank(resp.dataset.data)) {
                        if(parametrosParaSupri.IDBLQLANITSEMRELACOL == 'S') {
                            MessageService.showMessageByCode("PRODUTO_ITEM_SEM_RELACAO_PRODOL");
                            MessageService.showMessageByCode("PARAM_IDBLQLANITSEMRELACOL");
                        } else {
                            MessageService.showMessageByCode("PRODUTO_ITEM_SEM_RELACAO_PRODOL");
                            
                            General.callRestEngine("opl_relatorios#/checkIgualdadeItemPedidoOL", "Row", widget.currentRow).then(function(callback) {
                                General.callRestEngine("opl_relatorios#/insereItemPedidoOL", "Row", widget.currentRow).then(function(response) {
                                    widget.currentRow = {};
                                    
                                    MessageService.showMessageByCode("OPERACAO_SUCESSO");
                                    
                                    ScreenService.closeSwipe();
                                    
                                    const widgetItensPedido = widget.getParent();
                                    
                                    widgetItensPedido.activate();
                                    widgetItensPedido.reload();
                                }).catch(function(error) {
                                    if(error.data.error == "QTPROGENPEOL_EQUALS_ZERO")
                                        MessageService.showMessageByCode(error.data.error);
                                    else
                                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                });
                            }).catch(function(error) {
                                if(error.data.error == "ITEM_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                                    MessageService.showMessageByCode(error.data.error);
                                } else {
                                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                }
                            });
                        }
                    } else {
                        General.callRestEngine("opl_relatorios#/checkIgualdadeItemPedidoOL", "Row", widget.currentRow).then(function(callback) {
                            General.callRestEngine("opl_relatorios#/insereItemPedidoOL", "Row", widget.currentRow).then(function(response) {
                                widget.currentRow = {};
                                
                                MessageService.showMessageByCode("OPERACAO_SUCESSO");
                                
                                ScreenService.closeSwipe();
                                
                                const widgetItensPedido = widget.getParent();
                                
                                widgetItensPedido.activate();
                                widgetItensPedido.reload();
                            }).catch(function(error) {
                                if(error.data.error == "QTPROGENPEOL_EQUALS_ZERO")
                                    MessageService.showMessageByCode(error.data.error);
                                else
                                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                            });
                        }).catch(function(error) {
                            if(error.data.error == "ITEM_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                                MessageService.showMessageByCode(error.data.error);
                            } else {
                                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                            }
                        });
                    }
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.excluiItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
           
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                MessageService.confirmMessageByCode("CONFIRMA_EXCLUSAO_ITENS").then(function(confirmed) {
                    General.callRestEngine("opl_relatorios#/excluiItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                        widget.activate();
                        widget.reload();
                        
                        MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                });
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_DELETE");
        }
    };
    
    this.openWidgetAlteracaoDataEntregaItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoDataEntregaItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                ScreenService.openPopup(popUpWidget);
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaAlteracaoDataEntregaItemPedido = function(widget) {
        const dataProc = moment(getLocalVar("DTPROCESSA"), "DD/MM/YYYY").format("MM-DD-YYYY");
        const dataEscd = moment(widget.currentRow.NOVADTENTREGA, "DD/MM/YYYY").format("MM-DD-YYYY");
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_DTPROGENPEOL = moment(widget.currentRow.NOVADTENTREGA, "DD/MM/YYYY").format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            if(moment(dataEscd).isSameOrAfter(dataProc)) {
                General.callRestEngine("opl_relatorios#/alteraDataEntregaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("DTPROGENPEOL_EDIT_SUCCESS");
                }).catch(function(error) {
                    if(error.data.error == "DTPROGENPEOL_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                });
            } else {
                MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.openWidgetAlteracaoMarcaItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoMarcaItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                ScreenService.openPopup(popUpWidget);
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaAlteracaoMarcaItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_CDMARCA = widget.currentRow.CDMARCA;
           row.OLD_CDMARCA = row.CDMARCA;
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            General.callRestEngine("opl_relatorios#/alteraMarcaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                    
                widgetItensPedido.reload();
                    
                MessageService.showMessageByCode("CDMARCA_EDIT_SUCCESS");
            }).catch(function(error) {
                if(error.data.error == "CDMARCA_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                    MessageService.showMessageByCode(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                }
                ScreenService.closePopup();
                ScreenService.closePopup();
                
                widgetItensPedido.reload();
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.openWidgetAlteracaoProdutoItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoProdutoItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowBase = rowsSelecionadas[0];
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var permiteOperacao = true;
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        for(let i = 0; i < rowsSelecionadas.length; i++) {
            if(rowsSelecionadas[i].CDARVPROD !== rowBase.CDARVPROD) {
                permiteOperacao = false;
                break;
            }
        }
        
        var mascaraProduto = getLocalVar('CDPICTPROD');
        var fieldProduto = popUpWidget.getField('NMPRODUTO');
        
        mascaraProduto = mascaraProduto.split('.');
        
        var nivelProduto = mascaraProduto.length;
        
        /*fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == 'CDNVPRODUTO')
                filtro.value = nivelProduto;
        });*/
        
        fieldProduto.dataSourceFilter.forEach(function(row) {
            if(row.name == "P_CDFILIOPELOG") {
                row.value = CDFILIOPELOGPROD;
            }
        });
        
        popUpWidget.currentRow = {};
        
        popUpWidget.currentRow.AJUSTE_UNIDADE = '0';
		popUpWidget.currentRow.AJUSTE_QUANTIDADE = '0';
        
        if(rowsEmAberto.length == rowsSelecionadas.length && permiteOperacao) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                ScreenService.openPopup(popUpWidget);
            }
        } else if(!permiteOperacao) {
            MessageService.showMessageByCode("OPR_BLOCK_DIFF_PRODUCTS");
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.onChangeAjuste = function(field) {
        var value = angular.copy(field.value()),
        	minValue = '-99.99';
        
        if(typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        }
        
        if(value && parseFloat(value) < parseFloat(minValue)) {
            field.setValue('0');
            MessageService.showMessageByCode("VLR_MENOR_MENOS_99");
        }
        
        if (Util.isEmptyOrBlank(field.value())) {
    		field.setValue('0');
    	}
    };
    
    this.salvaAlteracaoProdutoItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_CDPRODUTO = widget.currentRow.CDPRODUTO;
           row.NEW_CDPRODESTO = widget.currentRow.CDPRODESTO;
           row.NEW_CDARVPROD = widget.currentRow.CDARVPROD;
           row.NEW_VRFATOCONV = widget.currentRow.VRFATOCONV;
           row.OLD_CDPRODUTO = row.CDPRODUTO;
           row.OLD_CDPRODESTO = row.CDPRODESTO;
           row.OLD_CDARVPROD = row.CDARVPROD;
           row.OLD_VRFATOCONV = row.VRFATOCONV;
           row.AJUSTE_UNIDADE = widget.currentRow.AJUSTE_UNIDADE;
           row.AJUSTE_QUANTIDADE = widget.currentRow.AJUSTE_QUANTIDADE;
           row.CDFILDEST = row.CDFILDEST.substr(0, 4);
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
           row.CONSIDERASOL = widget.currentRow.CONSIDERASOL;
        });
        
        if(widget.isValid()) {
            General.callRestEngine("opl_relatorios#/alteraProdutoItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                    
                widgetItensPedido.reload();
                
                if(response.messages.length > 0) {
                    response.messages.forEach(m => {
                        if(m.message == "ALL_ROWS_UPDATED") {
                            MessageService.showMessageByCode("CDPRODUTO_EDIT_SUCCESS");
                        }
                        if(m.message == "SOME_ROWS_UPDATED") {
                            MessageService.showMessageByCode("CDPRODUTO_SOME_EDIT_SUCCESS");
                        }
                        if(m.message == "NO_ROWS_UPDATED") {
                            MessageService.showMessageByCode("CDPRODUTO_NONE_EDIT_SUCCESS");
                        }
                    });
                }
            }).catch(function(error) {
                if(error.data.error == "CDPRODUTO_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                    MessageService.showMessageByCode(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                }
                ScreenService.closePopup();
                ScreenService.closePopup();
                
                widgetItensPedido.reload();
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.openWidgetAlteracaoQuantidadeItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoQuantidadeItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAbertoParcial = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0 || row.IDBAIXENPEOL == 1) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0 || row.IDBAIXEXOL == 1));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAbertoParcial.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                ScreenService.openPopup(popUpWidget);
            }
        } else {
            MessageService.showMessageByCode("ONLY_EMABERTO_PARCIAL_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaAlteracaoQuantidadeItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_QTPROGENPEOL = widget.currentRow.QTPROGENPEOL;
           row.OLD_QTPROGENPEOL = row.QTPROGENPEOL;
           row.CDFILDEST = row.CDFILDEST.substr(0, 4);
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            if(widget.currentRow.QTPROGENPEOL === "0,000" || widget.currentRow.QTPROGENPEOL === 0) {
                MessageService.confirmMessageByCode("CONFIRMA_EXCLUSAO_ITENS").then(function(confirmed) {
                    General.callRestEngine("opl_relatorios#/excluiItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                        
                        widgetItensPedido.reload();
                        
                        MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
                    }).catch(function(error) {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                        
                        widgetItensPedido.reload();
                        
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                }).catch(function(error) {});
            } else {
                General.callRestEngine("opl_relatorios#/alteraQuantidadeItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                        
                    widgetItensPedido.reload();
                        
                    MessageService.showMessageByCode("QTPROGENPEOL_EDIT_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.incluirLote = function(widget) {
        const popUpWidget = templateManager.container.getWidget("inclusaoDeLoteItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                ScreenService.openPopup(popUpWidget);
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaInclusaoDeLoteItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        const rowPai = rowsSelecionadas[0];
        
        rowPai.CDFILDEST1 = rowPai.CDFILDEST.split(" - ")[0];
        
        var inclusaoDeLote = false;
        
        rowsSelecionadas.forEach(row => {
            row.CDFILDEST1 = row.CDFILDEST.split(" - ")[0];
            row.NEW_CDLOTENVITOL = widget.currentRow.CDLOTENVITOL;
            row.OLD_CDLOTENVITOL = row.CDLOTENVITOL;
            row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
            
            if(row.CDFILIOPELOG == rowPai.CDFILIOPELOG && row.CDFILLANC == rowPai.CDFILLANC && row.CDFILDEST1 == rowPai.CDFILDEST1 && row.NRPEDEXOL == rowPai.NRPEDEXOL) {
                
            } else {
                inclusaoDeLote = true;
            }
        });
        
        if(inclusaoDeLote) {
            if(widget.isValid()) {
                General.callRestEngine("opl_relatorios#/incluiItemPedidoLoteDiversos", "Row", rowsSelecionadas).then(function(response) {
                   ScreenService.closePopup();
                   ScreenService.closePopup();
                   
                   widgetItensPedido.reload();
                   
                   MessageService.showMessageByCode("CDLOTENVITOL_NEW_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            }
        } else {
           if(widget.isValid()) {
               General.callRestEngine("opl_relatorios#/incluiItemPedidoLote", "Row", rowsSelecionadas).then(function(response) {
                   ScreenService.closePopup();
                   ScreenService.closePopup();
                   
                   widgetItensPedido.reload();
                   
                   MessageService.showMessageByCode("CDLOTENVITOL_NEW_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            } 
        }
    };
    
    this.incluirReserva = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                MessageService.confirmMessageByCode("RESERVA_QUESTION_INSERT").then(function(confirmed) {
                    General.callRestEngine("opl_relatorios#/inclusaoReservaItemPedido", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        
                        widget.reload();
                        
                        MessageService.showMessageByCode("RESEVA_NEW_SUCCESS");
                    }).catch(function(error) {
                        ScreenService.closePopup();
                        
                        widget.reload();
                        
                        if(error.data.error == "QTD_INDISPONIVEL_RESERVA") {
                            MessageService.showMessageByCode(error.data.error);
                        } else {
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        }
                    });
                });
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.excluirReserva = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                MessageService.confirmMessageByCode("RESERVA_QUESTION_DELETE").then(function(confirmed) {
                    General.callRestEngine("opl_relatorios#/exclusaoReservaItemPedido", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        
                        widget.reload();
                        
                        MessageService.showMessageByCode("RESEVA_DELETE_SUCCESS");
                    }).catch(function(error) {
                        ScreenService.closePopup();
                        
                        widget.reload();
                        
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                });
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.baixaManualItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAbertoParcial = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0 || row.IDBAIXENPEOL == 1) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0 || row.IDBAIXEXOL == 1));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           row.NEW_IDBAIXAOLSAI = '3';
           row.NEW_CDOPERBAIXA = getLocalVar("CDOPERADOR");
           row.NEW_DTBAIXTMPEOL = moment().format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
           
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        if(rowsEmAbertoParcial.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
			    });
			    
			    stringItem = rowsToMessage.join("<br><br>");
			    
			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                MessageService.confirmMessageByCode("CONFIRMA_BAIXA_MANUAL").then(function(confirmed) {
                    General.callRestEngine("opl_relatorios#/baixaManualItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        
                        widget.reload();
                        
                        MessageService.showMessageByCode("BAIXA_MANUAL_SUCCESS");
                    }).catch(function(error) {
                        ScreenService.closePopup();
                        
                        widget.reload();
                        
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                });
            }
        } else {
            MessageService.showMessageByCode("ONLY_EMABERTO_PARCIAL_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.desbloquearItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        const rowsDesbloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'N');
        });
        const rowsBloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'S' && ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0)));
        });
        var rowBlockOper = [];
        
        rowsBloqueadas.forEach(row => {
           row.NEW_CDOPERADOR = getLocalVar("CDOPERADOR");
           row.NEW_IDITMPEDOLBLOQ = 'N';
           row.NEW_DTBLOQITMPEDOL = moment().format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
           
           if(!verificaPermissaoItem(widget, row)) {
               rowBlockOper.push(row);
           }
        });
        
        if(rowsDesbloqueadas.length == rowsSelecionadas.length) {
            MessageService.showMessageByCode("ITEM_ALREADY_DESBLOQUEADO");
        } else {
            if(rowsEmAberto.length == rowsSelecionadas.length) {
                if(rowBlockOper.length >= 1) {
                    var rowsToMessage = [];
                    var stringItem = "";
                    
                    rowBlockOper.forEach(row => {
    					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
    										
    					rowsToMessage.push(prod);
    			    });
    			    
    			    stringItem = rowsToMessage.join("<br><br>");
    			    
    			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
                } else {
                    MessageService.confirmMessageByCode("CONFIRMA_DESBLOQUEIO_ITEM").then(function(confirmed) {
                        General.callRestEngine("opl_relatorios#/desbloqueioBloqueioItemPedidoOL", "Row", rowsBloqueadas).then(function(response) {
                            widget.reload();
                            
                            MessageService.showMessageByCode("DESBLOQUEIO_SUCCESS");
                        }).catch(function(error) {
                            widget.reload();
                            
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        });
                    });
                }
            } else {
                MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
            }
        }
    };
    
    this.bloquearItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        const rowsDesbloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'N' && ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0)));
        });
        const rowsBloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'S');
        });
        var rowBlockOper = [];
        
        rowsDesbloqueadas.forEach(row => {
           row.NEW_CDOPERADOR = getLocalVar("CDOPERADOR");
           row.NEW_IDITMPEDOLBLOQ = 'S';
           row.NEW_DTBLOQITMPEDOL = moment().format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
           
           if(!verificaPermissaoItem(widget, row)) {
               rowBlockOper.push(row);
           }
        });
        
        if(rowsBloqueadas.length == rowsSelecionadas.length) {
            MessageService.showMessageByCode("ITEM_ALREADY_BLOQUEADO");
        } else {
            if(rowsEmAberto.length == rowsSelecionadas.length) {
                if(rowBlockOper.length >= 1) {
                    var rowsToMessage = [];
                    var stringItem = "";
                    
                    rowBlockOper.forEach(row => {
                        var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
                        
                        rowsToMessage.push(prod);
    			    });
    			    
    			    stringItem = rowsToMessage.join("<br><br>");
    			    
    			    MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
                } else {
                    MessageService.confirmMessageByCode("CONFIRMA_BLOQUEIO_ITEM").then(function(confirmed) {
                        General.callRestEngine("opl_relatorios#/desbloqueioBloqueioItemPedidoOL", "Row", rowsDesbloqueadas).then(function(response) {
                            widget.reload();
                            
                            MessageService.showMessageByCode("BLOQUEIO_SUCCESS");
                        }).catch(function(error) {
                            widget.reload();
                            
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        });
                    });
                }
            } else {
                MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
            }
        }
    };
    
    this.entregaDiretaItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("entregaDiretaItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var rowsBloqueadas = [];
        
        rowsSelecionadas.forEach(row => {
           if(!verificaPermissaoItem(widget, row)) {
               rowsBloqueadas.push(row);
           }
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            if(rowsBloqueadas.length >= 1) {
                var rowsToMessage = [];
                var stringItem = "";
                
                rowsBloqueadas.forEach(row => {
					var prod = "Pedido: " + row.NRPEDEXOL + ", Produto: " + row.NMPRODUTO + ", Marca: " + row.NMMARCA + ", Entrega: " + row.DTPROGENPEOL;
										
					rowsToMessage.push(prod);
                });
                
                stringItem = rowsToMessage.join("<br><br>");
                
                MessageService.showMessageByCode("OPER_BLOCK_ITEM_GRUPOOPER", { ITEM: stringItem });
            } else {
                ScreenService.openPopup(popUpWidget);
            }
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.validaFieldOperador = function(widget) {
        widget.getField("SENHA").clearValue();
        widget.currentRow.SENHA = "";
        
        if(widget.currentRow.CDOPERADOR == getLocalVar("CDOPERADOR")) {
            delete  widget.getField("SENHA").validations;
            widget.getField("SENHA").readOnly = true;
        } else {
            widget.getField("SENHA").validations = {
                "required": true
            };
            widget.getField("SENHA").readOnly = false;
        }
        widget.activate();
    };
    
    this.validacoesLoginED = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
            row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
            row.CDOPERADOR = widget.currentRow.CDOPERADOR;
        });
        
        if(widget.isValid()) {
            if(widget.currentRow.CDOPERADOR == getLocalVar("CDOPERADOR")) {
                General.callRestEngine("opl_relatorios#/processoEntregaDiretaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                        
                    widgetItensPedido.reload();
                        
                    MessageService.showMessageByCode("ENTREGA_DIRETA_ITEM_SUCCESS");
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                General.callRestEngine("opl_relatorios#/validacaoSenhaED", "Row", widget.currentRow).then(function(response) {
                    General.callRestEngine("opl_relatorios#/processoEntregaDiretaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                            
                        widgetItensPedido.reload();
                            
                        MessageService.showMessageByCode("ENTREGA_DIRETA_ITEM_SUCCESS");
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }); 
                }).catch(function(error) {
                    if(error.data.error == "INVALID_PASSWORD") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                });
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.destinatarioNF = function(widget) {
        if(widget.currentRow.IDTIPOEMITAF == '1') {
            widget.getField("NMEMPRESA").validations = { required: true };
            
            ServiceEmissaoPedidoOL.empresasPorUnidade(widget.currentRow).then(function(callback) {
                widget.currentRow.CDEMPRESA = callback.dataset.sup07200_empresas_por_unidade[0].CDEMPRESA;
				widget.currentRow.NMEMPRESA = callback.dataset.sup07200_empresas_por_unidade[0].NMEMPRESA;
				
				widget.getField("NMEMPRESA").readOnly = true;
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else if(widget.currentRow.IDTIPOEMITAF == '2') {
            widget.getField("NMEMPRESA").validations = { required: true };
			widget.getField("NMEMPRESA").dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
			widget.getField("NMEMPRESA").readOnly = false;
			widget.getField("NMEMPRESA").reload();
			
			widget.currentRow.NMEMPRESA = '';
			widget.currentRow.CDEMPRESA = '';
        } else if(widget.currentRow.IDTIPOEMITAF == '3') {
            ServiceEmissaoPedidoOL.empresaClientePrincipal(widget.currentRow).then(function(callback) {
                if (callback.dataset.sup07200_empresa_cliente_principal.length) {
                    widget.currentRow.NMEMPRESA = callback.dataset.sup07200_empresa_cliente_principal[0].NMEMPRESA;
    			    widget.currentRow.CDEMPRESA = callback.dataset.sup07200_empresa_cliente_principal[0].CDEMPRESA;
                } else {
                    widget.currentRow.NMEMPRESA = '';
    			    widget.currentRow.CDEMPRESA = '';    
                }
                
                if (callback.dataset.sup07200_empresa_cliente_principal.length === 0) {
                    MessageService.showMessageByCode("SEM_CLIENTE_PRINCIPAL_FILIAL");
                    widget.currentRow.IDTIPOEMITAF = '2';
                    widget.currentRow.NMTIPOEMITAF = "Empresa Informada";
                    
                    widget.getField("NMEMPRESA").readOnly = false;
                    widget.getField("NMEMPRESA").validations = { required: true };
                    return false;
                } else {
                    widget.getField("NMEMPRESA").readOnly = true;
                    widget.getField("NMEMPRESA").validations = {};
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else {
            widget.getField("NMEMPRESA").readOnly = true;
            widget.getField("NMEMPRESA").validations = {};
            
            widget.currentRow.NMEMPRESA = '';
			widget.currentRow.CDEMPRESA = '';
        }
    };
    
    this.editaDadosPedido = function(widget) {
        const oldRow = angular.copy(widget.currentRow);
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        widget.oldRow = oldRow;
        widget.template = "widget/form.html";
        widget.edit();
        
        itensPedidosWidget.enabled = false;
        detalhesPedido.enabled = false;
    };
    
    this.cancelaEditaDadosPedido = function(args) {
        const activeWidget = templateManager.container.getActiveWidget();
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        activeWidget.template = "widget/form-view.html";
        activeWidget.reload();
        
        General.backOrCancel(args);
        
        activeWidget.list();
        activeWidget.reload();
        
        activeWidget.currentRow = activeWidget.oldRow;
        
        itensPedidosWidget.enabled = true;
        detalhesPedido.enabled = true;
    };
    
    this.salvaDadosPedido = function(widget) {
        const row = angular.copy(widget.currentRow);
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        delete row.__rightActions;
        delete row.__leftActions;
        
        row.__isNew = false;
        
        row.DTPEDEXOL = moment(row.DTPEDEXOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        
        if(widget.isValid()) {
            General.callRestEngine("opl_relatorios#/salvaDadosPedido", "Row", row).then(function(response) {
                widget.template = "widget/form-view.html";
                widget.list();
                widget.reload();
                
                itensPedidosWidget.enabled = true;
                detalhesPedido.enabled = true;
                
                MessageService.showMessageByCode("PEDIDO_EDIT_SUCCESS");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        }
    };
    
    this.adicionaNovoPedido = function(widget) {
        const widgetAdicionaNovoPedido = templateManager.container.getWidget("adicionaNovoPedido");
        const widgetTabbedNovoPedido = templateManager.container.getWidget("tabbedNovoPedidoWidget");
        const prodsNovoPedidoWidget = templateManager.container.getWidget("prodsNovoPedidoWidget");
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedidoWidget = templateManager.container.getWidget("detalhesPedido");
        
        widgetAdicionaNovoPedido.currentRow = widget.name === "dadosPedido" ? angular.copy(widget.currentRow) : {};
        
        if(Util.isEmptyOrBlank(widgetAdicionaNovoPedido.currentRow.CDFILDEST)) {
            widgetAdicionaNovoPedido.currentRow.CDFILDEST = getLocalVar("CDFILIAL");
            widgetAdicionaNovoPedido.currentRow.NMFILDEST = getLocalVar("NMFILIAL");
        }
        
        if(Util.isEmptyOrBlank(widgetAdicionaNovoPedido.currentRow.IDTIPOEMITAF)) {
            if(!Util.isEmptyOrBlank(parametrosParCmpsup.IDTIPEMITGER)) {
                if(parametrosParCmpsup.IDTIPEMITGER == '1') {
                    widgetAdicionaNovoPedido.currentRow.IDTIPOEMITAF = '1';
                    widgetAdicionaNovoPedido.currentRow.NMTIPOEMITAF = "Empresa da Unidade";
                } else if(parametrosParCmpsup.IDTIPEMITGER == '2') {
                    widgetAdicionaNovoPedido.currentRow.IDTIPOEMITAF = '2';
                    widgetAdicionaNovoPedido.currentRow.NMTIPOEMITAF = "Empresa Informada";
                } else {
                    widgetAdicionaNovoPedido.currentRow.IDTIPOEMITAF = '3';
                    widgetAdicionaNovoPedido.currentRow.NMTIPOEMITAF = "Cliente Principal";
                }
            }
        }
        
        self.destinatarioNF(widgetAdicionaNovoPedido);
        
        prodsNovoPedidoWidget.enabled = false;
        
        prodsNovoPedidoWidget.dataSource.data = [];
        
        delete widgetAdicionaNovoPedido.currentRow.NRPEDEXOL;
        
        widgetAdicionaNovoPedido.currentRow.DTPEDEXOL = moment().format("L");
        widgetAdicionaNovoPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
        widgetAdicionaNovoPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
        widgetAdicionaNovoPedido.currentRow.IDPEDEXOLEXTR = 'N';
        
        if(parametrosParaSupri.IDUTILCONSSOLIOLEXT === 'S') {
            widgetAdicionaNovoPedido.getField("IDPEDEXOLEXTR").readOnly = false;
            widgetAdicionaNovoPedido.getField("NMLOTENVITOL").readOnly = false;
        } else {
            widgetAdicionaNovoPedido.getField("IDPEDEXOLEXTR").readOnly = true;
            widgetAdicionaNovoPedido.getField("NMLOTENVITOL").readOnly = true;
        }
        
        itensPedidosWidget.enabled = false;
        
        detalhesPedidoWidget.enabled = false;
        
        self.destinatarioNF(widgetAdicionaNovoPedido);
        
        ScreenService.openSwipe(widgetTabbedNovoPedido);
    };
    
    this.baixaManualPedido = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        
        widget.currentRow.NEW_IDBAIXEXOL = 3;
        widget.currentRow.NEW_DTBAIXTMPEOL = moment().format('L');
        
        MessageService.confirmMessageByCode("BAIXA_MANUAL_PEDIDO_ASK").then(function(confirmed) {
            General.callRestEngine("opl_relatorios#/baixaManualPedido", "Row", widget.currentRow).then(function(response) {
                delete widget.currentRow.NEW_IDBAIXEXOL;
                widget.currentRow.IDBAIXEXOL = 3;
                
                itensPedidosWidget.reload();
                
                widget.getAction("editaDadosPedido").isVisible = false;
                widget.getAction("baixaManualPedido").isVisible = false;
                widget.getAction("cancelarPedido").isVisible = false;
                widget.getAction("encerrarPedido").isVisible = false;
                widget.getAction("exportarPedido").isVisible = false;
                widget.getAction("excluiPedido").isVisible = false;
                widget.getAction("emAbertoPedido").isVisible = true;
                
                ScreenService.closePopup();
                
                MessageService.showMessageByCode("BAIXA_MANUAL_SUCCESS");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.cancelarEncerrarPedido = function(widget, op) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        var message1, message2;
        
        widget.currentRow.NEW_IDBAIXEXOL = op;
        
        if(op == 5) {
            message1 = "CANCELA_PEDIDO_ASK";
            message2 = "CANCELA_PEDIDO_SUCCESS";
        } else {
            message1 = "ENCERRA_PEDIDO_ASK";
            message2 = "ENCERRA_PEDIDO_SUCCESS";
        }
        
        MessageService.confirmMessageByCode(message1).then(function(confirmed) {
            General.callRestEngine("opl_relatorios#/cancelaEncerraPedido", "Row", widget.currentRow).then(function(response) {
                delete widget.currentRow.NEW_IDBAIXEXOL;
                widget.currentRow.IDBAIXEXOL = op;
                
                itensPedidosWidget.reload();
                
                widget.getAction("editaDadosPedido").isVisible = false;
                widget.getAction("baixaManualPedido").isVisible = false;
                widget.getAction("cancelarPedido").isVisible = false;
                widget.getAction("encerrarPedido").isVisible = false;
                widget.getAction("exportarPedido").isVisible = false;
                widget.getAction("excluiPedido").isVisible = false;
                widget.getAction("emAbertoPedido").isVisible = true;
                
                ScreenService.closePopup();
                
                MessageService.showMessageByCode(message2);
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.emAbertoPedido = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        
        widget.currentRow.NEW_IDBAIXEXOL = 0;
        
        MessageService.confirmMessageByCode("EMABERTO_PEDIDO_ASK").then(function(confirmed) {
            General.callRestEngine("opl_relatorios#/emAbertoPedido", "Row", widget.currentRow).then(function(response) {
                delete widget.currentRow.NEW_IDBAIXEXOL;
                widget.currentRow.IDBAIXEXOL = null;
                
                itensPedidosWidget.reload();
                
                widget.getAction("editaDadosPedido").isVisible = true;
                widget.getAction("baixaManualPedido").isVisible = true;
                widget.getAction("cancelarPedido").isVisible = true;
                widget.getAction("encerrarPedido").isVisible = true;
                widget.getAction("excluiPedido").isVisible = true;
                widget.getAction("emAbertoPedido").isVisible = false;
                
                if(parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
                    widget.getAction("exportarPedido").isVisible = true;
                } else {
                    widget.getAction("exportarPedido").isVisible = false;
                }
                
                ScreenService.closePopup();
                
                MessageService.showMessageByCode("EMABERTO_SUCCESS");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.excluiPedido = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const stripeWidget = templateManager.container.getWidget("stripeWidget");
        const detalhesPedidoWidget = templateManager.container.getWidget("detalhesPedido");
        
        MessageService.confirmMessageByCode("EXCLUIR_PEDIDO_ASK").then(function(confirmed) {
            General.callRestEngine("opl_relatorios#/exclusaoPedido", "Row", widget.currentRow).then(function(response) {
                widget.currentRow = {};
                widget.enabled = false;
                
                itensPedidosWidget.currentRow = {};
                itensPedidosWidget.activate();
                itensPedidosWidget.reload();
                
                stripeWidget.currentRow = {};
                
                detalhesPedidoWidget.enabled = false;
                
                MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.cancelarNovoPedido = function(widget) {
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedidoWidget = templateManager.container.getWidget("detalhesPedido");
        
        MessageService.confirmMessageByCode("CANCEL_NOVO_PEDIDO").then(function(confirmed) {
            itensPedidosWidget.enabled = true;
        
            detalhesPedidoWidget.enabled = true;
            
            ScreenService.closeSwipe();
            ScreenService.closeSwipe();
            
            widgetDadosPedido.activate();
        });
    };
    
    this.abrirAbaProdutos = function(widget) {
        const prodsNovoPedidoWidget = templateManager.container.getWidget("prodsNovoPedidoWidget");
        
        prodsNovoPedidoWidget.enabled = true;
        
        widget.enabled = false;
        
        prodsNovoPedidoWidget.activate();
    };
    
    this.adicionaNovoProdutoPedido = function(widget) {
        const inclusaoProdutoNovoPedidoWidget = templateManager.container.getWidget("inclusaoProdutoNovoPedidoWidget");
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        var fieldProduto = inclusaoProdutoNovoPedidoWidget.getField('NMPRODUTO');
        
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == "P_PRODCMP")
                filtro.value = parametrosParaSupri.IDUTLPROCMP;
            if(filtro.name == "P_CDFILSOLI")
                filtro.value = "FILIAL_LOGADA";
            if(filtro.name == "CDFILIAL")
                filtro.value = adicionaNovoPedidoWidget.currentRow.CDFILDEST || null;
        });
        
        inclusaoProdutoNovoPedidoWidget.currentRow.DTPROGENPEOL = moment().format('L');
        
        ScreenService.openPopup(inclusaoProdutoNovoPedidoWidget);
    };
    
    this.salvaInclusaoProdutoNvoPedido = function(widget) {
        const dataProc = moment(getLocalVar("DTPROCESSA"), "DD/MM/YYYY").format("MM-DD-YYYY");
        const dataEscd = moment(widget.currentRow.DTPROGENPEOL, "DD/MM/YYYY").format("MM-DD-YYYY");
        const prodsNovoPedidoWidget = widget.getParent();
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        widget.currentRow.CDFILDEST = adicionaNovoPedidoWidget.currentRow.CDFILDEST;
        
        widget.currentRow.FINAL = permissoesFinaisOperador;
        widget.currentRow.GERAL = permissoesGeraisOperador;
        
        if(widget.isValid()) {
            if(moment(dataEscd).isSameOrAfter(dataProc)) {
                if(prodsNovoPedidoWidget.dataSource.data.length == 0) {
                    General.callRestEngine("opl_relatorios#/adqProcedureCarregaPerifili", "Row", widget.currentRow).then(function(response) {
                        var message = response.messages[0].message != undefined ? response.messages[0].message : null;
                        
                        if(message == "successful") {
                            prodsNovoPedidoWidget.dataSource.data.push(angular.copy(widget.currentRow));
                    
                            widget.currentRow = {};
                            
                            ScreenService.closePopup();
                            
                            MessageService.showMessageByCode("PRODUCT_INSERT_LIST_SUCCESS");
                        }
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                    
                } else {
                    var podeInserir = true;
                    
                    prodsNovoPedidoWidget.dataSource.data.forEach(row => {
                        if(row.DTPROGENPEOL == widget.currentRow.DTPROGENPEOL && row.CDMARCA == widget.currentRow.CDMARCA && row.CDPRODESTO == widget.currentRow.CDPRODESTO) {
                            podeInserir = false;
                        }
                    });
                    
                    if(podeInserir) {
                        General.callRestEngine("opl_relatorios#/adqProcedureCarregaPerifili", "Row", widget.currentRow).then(function(response) {
                            var message = response.messages[0].message != undefined ? response.messages[0].message : null;
                        
                            if(message == "successful") {
                                prodsNovoPedidoWidget.dataSource.data.push(angular.copy(widget.currentRow));
                        
                                widget.currentRow = {};
                                
                                ScreenService.closePopup();
                                
                                MessageService.showMessageByCode("PRODUCT_INSERT_LIST_SUCCESS");
                            }
                        }).catch(function(error) {
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        });
                    } else {
                        MessageService.showMessageByCode("ITEM_ALREADY_EXISTS_PEDIDO");
                    }
                }
            } else {
                MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            }
        }
    };
    
    this.excluiNovoProdutoPedido = function(widget) {
        const checkedRows = widget.getCheckedRows();
        const allRows = widget.dataSource.data;
        const returnRows = allRows.filter(function(rowA) {
            return !checkedRows.find(function(rowB) {
                return rowA.DTPROGENPEOL == rowB.DTPROGENPEOL && rowA.CDMARCA == rowB.CDMARCA && rowA.CDPRODESTO == rowB.CDPRODESTO;
            });
        });
        
        MessageService.confirmMessageByCode("CONFIRM_PRODUCT_DELETE_LIST").then(function(confirmed) {
            widget.dataSource.data = returnRows;
        });
    };
    
    this.finalizaNovoPedido = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const widgetStripe = templateManager.container.getWidget("stripeWidget");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        const rowFinal = {
            "DADOS": angular.copy(adicionaNovoPedidoWidget.currentRow),
            "PRODUTOS": angular.copy(widget.dataSource.data),
            "PARAMETROS": {
                "GERAL": permissoesGeraisOperador,
                "FINAL": permissoesFinaisOperador
            }
        };
        
        if(widget.dataSource.data.length > 0) {
            if(adicionaNovoPedidoWidget.isValid()) {
                MessageService.confirmMessageByCode("CONFIRMA_NOVO_PEDIDO").then(function(confirmed) {
                    General.callRestEngine("opl_relatorios#/inclusaoPedido", "Row", rowFinal).then(function(response) {
                        widgetDadosPedido.currentRow = adicionaNovoPedidoWidget.currentRow;
                        widgetDadosPedido.getAction("editaDadosPedido").isVisible = true;
                        widgetDadosPedido.getAction("baixaManualPedido").isVisible = true;
                        widgetDadosPedido.getAction("cancelarPedido").isVisible = true;
                        widgetDadosPedido.getAction("encerrarPedido").isVisible = true;
                        widgetDadosPedido.getAction("excluiPedido").isVisible = true;
                        widgetDadosPedido.getAction("emAbertoPedido").isVisible = false;
                        
                        if(parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
                            widgetDadosPedido.getAction("exportarPedido").isVisible = true;
                        } else {
                            widgetDadosPedido.getAction("exportarPedido").isVisible = false;
                        }
                        
                        adicionaNovoPedidoWidget.currentRow = {};
                        
                        itensPedidosWidget.currentRow = {};
                        itensPedidosWidget.reload();
                        itensPedidosWidget.enabled = true;
                        
                        widgetStripe.currentRow = {};
                        
                        widget.dataSource.data = [];
                        
                        widgetDetalhesPedido.enabled = true;
                        
                        ScreenService.closeSwipe();
                        ScreenService.closeSwipe();
                        
                        MessageService.showMessageByCode("NEW_PEDIDO_SUCCESS");
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                }).catch(function(declined) {
                    adicionaNovoPedidoWidget.activate();
                });
            } else {
                adicionaNovoPedidoWidget.activate();
                
                MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            }
        } else {
            MessageService.showMessageByCode("ONE_PRODUCT_NEC_INSERT");
        }
    };
    
    this.exportarPedido = function(widget) {
        const widgetFatPrec = templateManager.container.getWidget("exportarPedidoOLWidget");
        
        widget.currentRow.IDENVIOITMPEDOL = parametrosParaSupri.IDENVIOITMPEDOL;
        
        MessageService.confirmMessageByCode("CONFIRM_EXPORT_PEDIDO").then(function(confirmed) {
            if(parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
                ScreenService.openPopup(widgetFatPrec);
            } else {
                General.callRestEngine("opl_relatorios#/exportarPedidoOL", "Row", widget.currentRow).then(function(response) {
                    ScreenService.closePopup();
                    
                    MessageService.showMessageByCode("PEDIDO_EXPORTADO_SUCESSO");
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            }
        });
    };
    
    this.salvaExportaPedido = function(widget) {
        const widgetPedido = widget.getParent();
        
        var currentRow = angular.copy(widgetPedido.currentRow);
        
        currentRow.CDFATPRECO = widget.currentRow.CDFATPRECO;
        
        if(widget.isValid()) {
            General.callRestEngine("opl_relatorios#/exportarPedidoOL", "Row", currentRow).then(function(response) {
                ScreenService.closePopup();
                    
                MessageService.showMessageByCode("PEDIDO_EXPORTADO_SUCESSO");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        }
    };
    
    this.importacaoSolicitacaoOL = function(widget) {
        const importacaoSolicitacaoComprasOLWidget = templateManager.container.getWidget("importacaoSolicitacaoComprasOLWidget");
        
        importacaoSolicitacaoComprasOLWidget.currentRow = {};
        
        if(parametrosParaSupri.IDUTILCONSSOLIOLEXT === 'S') {
            importacaoSolicitacaoComprasOLWidget.getField("NMFATPRECO").isVisible = true;
            importacaoSolicitacaoComprasOLWidget.getField("EXTRA").isVisible = true;
            importacaoSolicitacaoComprasOLWidget.getField("NMLOTENVITOL").isVisible = true;
            importacaoSolicitacaoComprasOLWidget.getField("EXTRA").readOnly = false;
            importacaoSolicitacaoComprasOLWidget.getField("NMLOTENVITOL").readOnly = false;
        } else {
            importacaoSolicitacaoComprasOLWidget.getField("NMFATPRECO").isVisible = false;
            importacaoSolicitacaoComprasOLWidget.getField("EXTRA").isVisible = false;
            importacaoSolicitacaoComprasOLWidget.getField("NMLOTENVITOL").isVisible = false;
            importacaoSolicitacaoComprasOLWidget.getField("EXTRA").readOnly = true;
            importacaoSolicitacaoComprasOLWidget.getField("NMLOTENVITOL").readOnly = true;
        }
        
        if(parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
            importacaoSolicitacaoComprasOLWidget.getField("NMFATPRECO").isVisible = true;
        } else {
            importacaoSolicitacaoComprasOLWidget.getField("NMFATPRECO").isVisible = false;
        }
        
        ScreenService.openPopup(importacaoSolicitacaoComprasOLWidget);
    };
    
    this.readOnlyImportSolFields = function(widget) {
        const fieldNaoConsid = widget.getField("NCONSIDERASUBGRUPO");
        const fieldSubgrupo = widget.getField("CDSUBGRPROD");
        const fieldProdIni = widget.getField("NMPRODINI");
        const fieldProdFin = widget.getField("NMPRODFIN");
        
        fieldNaoConsid.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : false;
        
        fieldSubgrupo.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : widget.currentRow.NCONSIDERASUBGRUPO == 'S' ? true : false;
        
        fieldProdIni.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : false;
        
        fieldProdFin.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : false;
        
        if(widget.currentRow.TODOSPRODUTOS == 'S') {
            widget.currentRow.CDSUBGRPROD = null;
            widget.currentRow.NCONSIDERASUBGRUPO = 'S';
            widget.currentRow.NMPRODINI = null;
            widget.currentRow.CDPRODINI = null;
            widget.currentRow.NMPRODFIN = null;
            widget.currentRow.CDPRODFIN = null;
            
            delete fieldProdIni.validations;
            delete fieldProdFin.validations;
        } else {
            fieldProdIni.validations = {
                "required": true
            };
            fieldProdFin.validations = {
                "required": true
            };
        }
        
        widget.activate();
    };
    
    this.confirmaImportSolOL = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        widget.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
        widget.currentRow.CDPRODINI = widget.currentRow.CDPRODINI ? widget.currentRow.CDPRODINI : null;
        widget.currentRow.CDPRODFIN = widget.currentRow.CDPRODFIN ? (widget.currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20) : null;
        widget.currentRow.CDREGIAOBKP = (!widget.currentRow.CDREGIAO || widget.currentRow.CDREGIAO.length == 0) ? null : '_' + widget.currentRow.CDREGIAO.join('_') + '_';
        widget.currentRow.CDSUBGRPRODBKP = (!widget.currentRow.CDSUBGRPROD || widget.currentRow.CDSUBGRPROD.length == 0) ? null : '_' + widget.currentRow.CDSUBGRPROD.join('_') + '_';
        widget.currentRow.CDGRUPPRODBKP = (!widget.currentRow.CDGRUPPROD || widget.currentRow.CDGRUPPROD.length == 0) ? null : widget.currentRow.CDGRUPPROD[0];
        widget.currentRow.CDGRUPFILIBKP = (!widget.currentRow.CDGRUPFILI || widget.currentRow.CDGRUPFILI.length == 0) ? null : '_' + widget.currentRow.CDGRUPFILI.join('_') + '_';
        
        if(widget.isValid()) {
            MessageService.confirmMessageByCode("CONFIRM_IMPORT_SOL_OL").then(function(confirmed) {
                General.callRestEngine("opl_relatorios#/adqValidacoes", "Row", widget.currentRow).then(function(response) {
                    const produtos = response.dataset.adqValidacoes;
                    const inconsistWidget = templateManager.container.getWidget("inconsistenciaProdutosImportWidget");
                    
                    if(!Util.isEmptyOrBlank(produtos) && produtos.length >= 1) {
                        MessageService.confirmMessageByCode("INCONS_PROCESSO_IMPORTACAO").then(function(confirmed) {
                            inconsistWidget.dataSource.data = produtos;
                            
                            ScreenService.openPopup(inconsistWidget);
                            
                            inconsistWidget.reload();
                            inconsistWidget.activate();
                        }).catch(function(declined) {
                            General.callRestEngine("opl_relatorios#/importacaoSolicitacaoOL", "Row", widget.currentRow).then(function(response) {
                                ScreenService.closePopup();
                                
                                itensPedidosWidget.reload();
                                
                                widgetDetalhesPedido.reload();
                                
                                MessageService.showMessageByCode("IMPORT_SUCCESS");
                            }).catch(function(error) {
                                if(error.data.error == "ERROR_APUR" || error.data.error == "APUR_NOT_RESULTS") {
                                    MessageService.showMessageByCode(error.data.error);
                                } else {
                                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                }
                            });
                        });
                    } else {
                       General.callRestEngine("opl_relatorios#/importacaoSolicitacaoOL", "Row", widget.currentRow).then(function(response) {
                            ScreenService.closePopup();
                            
                            itensPedidosWidget.reload();
                            
                            widgetDetalhesPedido.reload();
                            
                            MessageService.showMessageByCode("IMPORT_SUCCESS");
                        }).catch(function(error) {
                            if(error.data.error == "ERROR_APUR" || error.data.error == "APUR_NOT_RESULTS") {
                                MessageService.showMessageByCode(error.data.error);
                            } else {
                                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                            }
                        });
                    }
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.finalizaImportSolIncons = function(widgetIncons) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widget = widgetIncons.getParent();
        
        General.callRestEngine("opl_relatorios#/importacaoSolicitacaoOL", "Row", widget.currentRow).then(function(response) {
            ScreenService.closePopup();
            ScreenService.closePopup();
                                
            itensPedidosWidget.reload();
                                
            widgetDetalhesPedido.reload();
                                
            MessageService.showMessageByCode("IMPORT_SUCCESS");
        }).catch(function(error) {
            if(error.data.error == "ERROR_APUR" || error.data.error == "APUR_NOT_RESULTS") {
                MessageService.showMessageByCode(error.data.error);
            } else {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            }
        });
    };
    
    this.emissaoPedidosOL = function(widget) {
        const emissaoPedidosOLWidget = templateManager.container.getWidget("emissaoPedidosOLWidget");
        const widgetItensPedido = templateManager.container.getWidget("itensPedidosWidget");

        emissaoPedidosOLWidget.currentRow = {};
        emissaoPedidosOLWidget.currentRow.TCDLOTENVITOL = 'N';
        emissaoPedidosOLWidget.currentRow.IDBAIXAAFSAI = [ '0', '1', '2', '3' ];
        emissaoPedidosOLWidget.currentRow.IDBAIXAAFENT = [ '0', '1', '2', '3', '4', '5' ];
        emissaoPedidosOLWidget.currentRow.PEDOLEXTR = [ 'S', 'N' ];
        emissaoPedidosOLWidget.currentRow.CDFILIOPELOG = widgetItensPedido.appliedFilter.FILTER_ROW.NMFILIALOL;
        emissaoPedidosOLWidget.currentRow.CDFILDEST = widgetItensPedido.appliedFilter.FILTER_ROW.NMFILIAL;
        emissaoPedidosOLWidget.currentRow.NCONSIDERASUBGRUPO = widgetItensPedido.appliedFilter.FILTER_ROW.NCONSIDERASUBGRUPO;
        if(emissaoPedidosOLWidget.currentRow.NCONSIDERASUBGRUPO == 'N') {
            emissaoPedidosOLWidget.currentRow.CDGRUPPROD = widgetItensPedido.appliedFilter.FILTER_ROW.CDGRUPPROD;
            emissaoPedidosOLWidget.currentRow.CDSUBGRPROD = widgetItensPedido.appliedFilter.FILTER_ROW.CDSUBGRPROD;
            emissaoPedidosOLWidget.currentRow.NMSUBGRPROD = widgetItensPedido.appliedFilter.FILTER_ROW.NMSUBGRPROD;
            
            emissaoPedidosOLWidget.getField("CDSUBGRPROD").readOnly = false;
        } else {
            emissaoPedidosOLWidget.getField("CDSUBGRPROD").readOnly = true;
        }
        emissaoPedidosOLWidget.currentRow.CDROTATRANS = widgetItensPedido.appliedFilter.FILTER_ROW.CDROTATRANS;
        emissaoPedidosOLWidget.currentRow.DTPROGENPEOL = widgetItensPedido.appliedFilter.FILTER_ROW.DTPROGENPEOL;
        emissaoPedidosOLWidget.currentRow.DTPROGEMBARQ = widgetItensPedido.appliedFilter.FILTER_ROW.DTPROGEMBARQ;
        emissaoPedidosOLWidget.currentRow.NMPRODINI = widgetItensPedido.appliedFilter.FILTER_ROW.NMPRODINI;
        emissaoPedidosOLWidget.currentRow.NMPRODFIN = widgetItensPedido.appliedFilter.FILTER_ROW.NMPRODFIN;
        emissaoPedidosOLWidget.currentRow.PEDOLEXTR = widgetItensPedido.appliedFilter.FILTER_ROW.PEDOLEXTR;
        emissaoPedidosOLWidget.currentRow.TCDLOTENVITOL = widgetItensPedido.appliedFilter.FILTER_ROW.TCDLOTENVITOL;
        if(emissaoPedidosOLWidget.currentRow.TCDLOTENVITOL == 'L') {
            emissaoPedidosOLWidget.currentRow.CDLOTE = widgetItensPedido.appliedFilter.FILTER_ROW.CDLOTE;
            emissaoPedidosOLWidget.currentRow.CDLOTENVITOL = widgetItensPedido.appliedFilter.FILTER_ROW.CDLOTENVITOL;
            emissaoPedidosOLWidget.currentRow.NMLOTENVITOL = widgetItensPedido.appliedFilter.FILTER_ROW.NMLOTENVITOL;
            
            emissaoPedidosOLWidget.getField("CDLOTE").readOnly = false;
            emissaoPedidosOLWidget.getField("CDLOTE").validations = {
                "required": true
            };
        } else {
            emissaoPedidosOLWidget.getField("CDLOTE").readOnly = true;
            delete emissaoPedidosOLWidget.getField("CDLOTE").validations;
        }
        
        emissaoPedidosOLWidget.getField("CDFILIOPELOG").reload();
        emissaoPedidosOLWidget.getField("CDFILDEST").reload();
        emissaoPedidosOLWidget.getField("CDSUBGRPROD").reload();
        emissaoPedidosOLWidget.getField("CDROTATRANS").reload();
        emissaoPedidosOLWidget.getField("NMPRODINI").reload();
        emissaoPedidosOLWidget.getField("NMPRODFIN").reload();
        emissaoPedidosOLWidget.getField("CDLOTE").reload();
        
        ScreenService.openPopup(emissaoPedidosOLWidget);
    };
    
    this.changeFieldRota = function(widget) {
        const fieldRota = widget.getField("CDROTATRANS");
        
        if(widget.currentRow.NCONSIDERAROTA === 'N') {
            fieldRota.readOnly = false;
            fieldRota.reload();
            fieldRota.setValue(null);
        } else {
            fieldRota.readOnly = true;
            fieldRota.reload();
            fieldRota.setValue(null);
        }
        
        widget.activate();
    };
    
    //Valida o tipo de inconsitencia de cada produto
    function validaProdsIncons(produtos) {
        //Para cada produto, faz-se as modificaçãoes
        produtos.forEach(produto => {
            //Altera o formato da data a ser exibida
            if(!Util.isEmptyOrBlank(produto.DTPROGENTAF) && produto.DTPROGENTAF !== ''){
               produto.DTPROGENTAF = produto.DTPROGENTAF.substr(0, 10); 
            }
            //Armazena o value
            var CDERRO = produto.CDERRO;
            //Se a string.length for maior que 6
            if(CDERRO.length >= 6) {
                //Separa os values
                CDERRO = produto.CDERRO.split("_");
                //Se a posição 0 for vazia, remove-a
                if(CDERRO[0] === ""){
                    CDERRO.shift();
                }
                //Se tiver 2 itens
                if(CDERRO.length == 2){
                    produto.CDERRO = CDERRO[0] + " - " + CDERRO[1];
                //Se tiver 3 ou mais itens
                }else if(CDERRO.length >= 3) {
                    //Guarda o primeiro e o ultimo item da array
                    let firstItem = CDERRO.shift() + " ";
                    let lastItem = " - " + CDERRO.pop();
                    let itens = [];
                    //Passa por cada item restante(que está entre o primeiro e ultimo item)
                    CDERRO.forEach(item => {
                        if(item !== firstItem && item !== lastItem){
                            item = " - " + item;
                            itens.push(item);
                        }
                    });
                    //Transforma a array em string
                    itens = itens.toString();
                    //Remove as virgulas (,)
                    itens = itens.replace(/,/g, "").replace(/\./g, "");
                    //Concatena os itens
                    itens = firstItem + itens + lastItem;
                    //Tranforma em string novamente
                    itens = itens.toString();
                    //Retorna uma string montada com todos os itens modificados
                    produto.CDERRO = itens;
                }
            //Se a string.length fir igual a 3
            }else if(CDERRO.length == 3){
                //Separa os values
                CDERRO = produto.CDERRO.split("_");
                //Se a posição 0 for vazia, remove-a
                if(CDERRO[0] === ""){
                    CDERRO.shift();
                }
                //Retorna uma string montada com todos os itens modificados
                produto.CDERRO = CDERRO[0];
            }
        });
        //Retorna a array completa
        return produtos;
    }
    
    //Confirmação da emissao dos pedidos
    this.confirmaEmissaoPedidosOL = function(widget, opcao) {
        //Armazena os dados 
        const row = angular.copy(widget.currentRow);
        const widgetGeraRelatorioEmissao = templateManager.container.getWidget("geraRelatorioEmissaoWidget");
        const widgetEmail = templateManager.container.getWidget("enviaEmailEmissaoWidget");
        var reportRow = {};
        opEmissao = opcao;
        //Verifica se o form está válido
        if(widget.isValid()) {
            //Armazena os dados para geração de relatório
            reportRow.P_CDCLIENTE = '';
            reportRow.P_TCDCLIENTE = 'T';
            reportRow.P_CDOPERADOR = getLocalVar('CDOPERADOR');
            reportRow.P_CDFILIOL = Util.isEmptyOrBlank(row.CDFILIOPELOG) ? '' : '_' + row.CDFILIOPELOG.join('_') + '_';
            reportRow.P_TCDFILIOL = Util.isEmptyOrBlank(row.CDFILIOPELOG) ? 'T' : '';
            reportRow.L_ROTA = Util.isEmptyOrBlank(row.CDROTATRANS) ? 'T' : '_' + row.CDROTATRANS.join('_') + '_';
            reportRow.L_ROTA1 = Util.isEmptyOrBlank(row.CDROTATRANS) ? 'T' : '_' + row.CDROTATRANS.join('_') + '_';
            reportRow.P_ROTA = Util.isEmptyOrBlank(row.CDROTATRANS) ? 'T' : '_' + row.CDROTATRANS.join('_') + '_';
            reportRow.P_CDFILIAL = Util.isEmptyOrBlank(row.CDFILDEST) ? '' : '_' + row.CDFILDEST.join('_') + '_';
            reportRow.P_TCDFILIAL = Util.isEmptyOrBlank(row.CDFILDEST) ? 'T' : '';
            reportRow.P_DTENTRINI = (Util.isEmptyOrBlank(row.DTPROGENPEOL.start) && Util.isEmptyOrBlank(row.DTPROGENPEOL.end)) ? '' : moment(row.DTPROGENPEOL.start, "DD/MM/YYYY").format('L');
            reportRow.P_DTENTRFIN = (Util.isEmptyOrBlank(row.DTPROGENPEOL.start) && Util.isEmptyOrBlank(row.DTPROGENPEOL.end)) ? '' : moment(row.DTPROGENPEOL.end, "DD/MM/YYYY").format('L');
            reportRow.P_TDTENTR = (Util.isEmptyOrBlank(row.DTPROGENPEOL.start) && Util.isEmptyOrBlank(row.DTPROGENPEOL.end)) ? 'T' : '';
            reportRow.P_DTEMBINI = (Util.isEmptyOrBlank(row.DTPROGEMBARQ.start) && Util.isEmptyOrBlank(row.DTPROGEMBARQ.end)) ? '' : moment(row.DTPROGEMBARQ.start, "DD/MM/YYYY").format('L');
            reportRow.P_DTEMBFIN = (Util.isEmptyOrBlank(row.DTPROGEMBARQ.start) && Util.isEmptyOrBlank(row.DTPROGEMBARQ.end)) ? '' : moment(row.DTPROGEMBARQ.end, "DD/MM/YYYY").format('L');
            reportRow.P_TDTEMB = (Util.isEmptyOrBlank(row.DTPROGEMBARQ.start) && Util.isEmptyOrBlank(row.DTPROGEMBARQ.end)) ? 'T' : '';
            reportRow.P_SUBGRUPO = row.NCONSIDERASUBGRUPO === 'S' ? 'N' : Util.isEmptyOrBlank(row.CDSUBGRPROD) ? 'T' : '_' + row.CDSUBGRPROD.join('_') + '_';
            reportRow.P_CDGRUPPROD = row.NCONSIDERASUBGRUPO === 'S' ? '' : parametrosParaSupri.CDGRUPPROD;
            reportRow.P_CDPRODINI = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? '' : row.CDPRODINI;
            reportRow.P_CDPRODFIN = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? "" : (row.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20);
            reportRow.P_TPRODUTO = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? 'T' : null;
            reportRow.P_CDPRODFINTEXT = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? '' : row.CDPRODFIN;
            reportRow.L_PRODUTO = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? 'T' : 'X';
            reportRow.P_PRODUTO = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? 'T' : 'X';
            reportRow.L_OPERADOR = getLocalVar("CDOPERADOR");
            reportRow.L_OPERADOR1 = getLocalVar("CDOPERADOR");
            reportRow.P_OPERADOR = getLocalVar("CDOPERADOR");
            reportRow.P_NMPRODINI = Util.isEmptyOrBlank(row.NMPRODINI) ? '' : row.NMPRODINI;
            reportRow.P_NMPRODFIN = Util.isEmptyOrBlank(row.NMPRODFIN) ? '' : row.NMPRODFIN;
            reportRow.P_IDSITUACAO = 'P';
            reportRow.P_IDBAIXEXOL = '_' + row.IDBAIXAAFENT.join('_') + '_';
            reportRow.P_IDBAIXEXSAI = '_' + row.IDBAIXAAFSAI.join('_') + '_';
            reportRow.P_PEDEXOLEXTR = row.PEDOLEXTR.length == 2 ? 'T' : row.PEDOLEXTR[0] === 'S' ? 'S' : 'N';
            reportRow.P_CDLOTENVITOL = row.TCDLOTENVITOL === 'S' ? 'S' : row.TCDLOTENVITOL === 'N' ? 'T' : row.TCDLOTENVITOL === 'L' ? Util.isEmptyOrBlank(row.CDLOTENVITOL) ? 'T' : '_' + row.CDLOTENVITOL.join('_') + '_' : 'T';
            reportRow.P_NRSEQRUPTURAOL = '';
            reportRow.P_TNRSEQRUPTURAOL = 'T';
            reportRow.P_TROTA = (Util.isEmptyOrBlank(row.P_ROTA)) ? 'T' : null;
            reportRow.P_IDPEDEXTRA = row.PEDOLEXTR.length == 2 ? 'T' : row.PEDOLEXTR[0] === 'S' ? 'S' : 'N';
            reportRow.STRATEGY = widget.currentRow.RELATORIO.split('.')[1];
            reportRow.__report_name = widget.currentRow.RELATORIO.split('.')[0];
            reportRow.reportLabel = widget.currentRow.RELATORIO.split('.')[0];
            reportRow.QR2TYPE = widget.currentRow.QR2TYPE;
            //ALtera o valor do checkbox do widget "Enviar E-Mail"
            widgetEmail.getField("SENDOPERATOR").label = "Enviar Cópia para " + getLocalVar("NMOPERADOR");
            //Armazena os dados dos itens para geração do relatório
            widget.reportRow = reportRow;
            //Retorna cookies
            ServiceEmissaoPedidoOL.retornaCookieEmail().then(function(messages) {
                //Armazena os cookies
                var cookies = messages.messages[0].message;
                //Determina os cookies para cada campo
                widgetEmail.currentRow.NOME_ARQUIVO = cookies.shift();
                widgetEmail.currentRow.MENSAGEM = cookies.shift();
                widgetEmail.currentRow.ASSUNTO = cookies.shift();
                widgetEmail.currentRow.SENDOPERATOR = cookies.shift();
                widgetEmail.currentRow.EMAILS = cookies.shift();
                //Mensagens de erro
                const promises = [
                    MessageService.getMessageByCode("SUCCESS_MESSAGE"),
                    MessageService.getMessageByCode("ERROR_MESSAGE"),
                    MessageService.getMessageByCode("EMAIL_N_REGISTERED"),
                    MessageService.getMessageByCode("EMAIL_SEND_SUCCESS"),
                    MessageService.getMessageByCode("EMAIL_SEND_FAILED")
                ];
                //Promisse retornada
                Promise.all(promises).then((response) => {
                   const msgArray = {
                        'SUCCESS_MESSAGE': response.shift(),
                        'ERROR_MESSAGE': response.shift(),
                        'EMAIL_N_REGISTERED': response.shift(),
                        'EMAIL_SEND_SUCCESS': response.shift(),
                        'EMAIL_SEND_FAILED': response.shift()
                    };
                    widgetEmail.currentRow.MSGARRAY = msgArray;
                });
                //Altera os valores dos seguintes campos do widget de Email
                if(!widgetEmail.currentRow.NOME_ARQUIVO) {
                    widgetEmail.currentRow.NOME_ARQUIVO = "";
                }
                if(!widgetEmail.currentRow.EMAILS) {
                    widgetEmail.currentRow.EMAILS = "";
                }
                if(!widgetEmail.currentRow.MENSAGEM) {
                    widgetEmail.currentRow.MENSAGEM = "Envio de E-Mail Emissão de Pedidos OL";
                }
                if(!widgetEmail.currentRow.ASSUNTO) {
                    widgetEmail.currentRow.ASSUNTO = "Envio de E-Mail Emissão de Pedidos OL";
                }
                //Gera/Envia relatorio
                if(widget.isValid() && reportRow.STRATEGY) {
                    if(opcao == 1) {
                        //Abre o popup de gerar relatório
                        ScreenService.openPopup(widgetGeraRelatorioEmissao);
                    } else {
                        //Abre o popup de enviar relatório por email
                        ScreenService.openPopup(widgetEmail);
                    }
                }    
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            ScreenService.closePopup();
        }
    };
    
    //Seta a label do popup Inconsistências de Produtos da Emissão
    this.setLabelPopupInconsistenciaProdutoEmissao = function(){
        var widgetInconsistencia = templateManager.container.getWidget('inconsistenciaProdutosEmissaoWidget');
        setTimeout(() => {
            ScreenService.showLoader();
	        MessageService.getMessageByCode('LABEL_POPUP_INSCONSISTENCIA_PRODUTO_EMISSAO').then(function(response){
                var label = response;
                widgetInconsistencia.label = label;
                widgetInconsistencia.redraw();
                ScreenService.hideLoader();
            });
        }, 600);
    };
    
    //Finaliza a emissao de insonsistencia
    this.finalizaEmissaoIncons = function(widget) {
        //Armazena os dados
        const widgetcmp04900 = templateManager.container.getWidget("cmp04900");
        const widgetEmissao = widget.getParent();
        const reportRow = widgetEmissao.reportRow;
        const widgetEmail = templateManager.container.getWidget("enviaEmailEmissaoWidget");
        const row = {
            "DADOS_EMAIL": widgetEmail.currentRow,
            "CURRENT_ROW": reportRow
        };
        //Fecha o popup
        ScreenService.closePopup();
        //Valida o formulário
        if(widgetEmissao.isValid()) {
            //Se "opEmissao" !== 1 continua a geração de relatorio txt e envio de email  .. Senao continua a execução de gerar relatorio txt.
            if(opEmissao !== 1) {
                if(reportRow.P_GERARESERVA == 'S') {
                    if(Util.isEmptyOrBlank(permissoesFinaisOperador)) {
                        if(Util.isEmptyOrBlank(permissoesGeraisOperador)) {
                            MessageService.confirmMessageByCode("BLOQUEAR_PEDIDOS").then(function(confirmed) {
                                General.callRestEngine("opl_relatorios#/bloqueiaPedidoOL").then(function(response) {
                                    if(widgetEmail.isValid()) {
                                        ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                                            exibeLogEmail(widgetEmail, success.messages, false);
                                        }).catch(function(error) {
                                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                        });
                                    }
                                }).catch(function(error) {
                                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                });
                            }).catch(function(declined) {
                                if(widgetEmail.isValid()) {
                                    ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                                        exibeLogEmail(widgetEmail, success.messages, false);
                                    }).catch(function(error) {
                                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                    });
                                }
                            });
                        } else {
                            if(permissoesGeraisOperador.indexOf("SVOL") == -1) {
                                MessageService.confirmMessageByCode("BLOQUEAR_PEDIDOS").then(function(confirmed) {
                                    General.callRestEngine("opl_relatorios#/bloqueiaPedidoOL").then(function(response) {
                                        if(widgetEmail.isValid()) {
                                            ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                                                exibeLogEmail(widgetEmail, success.messages, false);
                                            }).catch(function(error) {
                                                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                            });
                                        }
                                    }).catch(function(error) {
                                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                    });
                                }).catch(function(declined) {
                                    if(widgetEmail.isValid()) {
                                        ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                                            exibeLogEmail(widgetEmail, success.messages, false);
                                        }).catch(function(error) {
                                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                        });
                                    }
                                });
                            } else {
                                MessageService.showMessageByCode("OPER_BLOCK");
                            }
                        }
                    } else {
                        if(permissoesGeraisOperador.indexOf("SVOL") != -1 && permissoesFinaisOperador.indexOf("SVOL") != -1) {
                            MessageService.confirmMessageByCode("BLOQUEAR_PEDIDOS").then(function(confirmed) {
                                General.callRestEngine("opl_relatorios#/bloqueiaPedidoOL").then(function(response) {
                                    if(widgetEmail.isValid()) {
                                        ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                                            exibeLogEmail(widgetEmail, success.messages, false);
                                        }).catch(function(error) {
                                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                        });
                                    }
                                }).catch(function(error) {
                                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                });
                            }).catch(function(declined) {
                                if(widgetEmail.isValid()) {
                                    ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                                        exibeLogEmail(widgetEmail, success.messages, false);
                                    }).catch(function(error) {
                                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                    });
                                }
                            });
                        } else {
                            MessageService.showMessageByCode("OPER_BLOCK");
                        }
                    }
                } else {
                    if(widgetEmail.isValid()) {
                        ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                            exibeLogEmail(widgetEmail, success.messages, false);
                        }).catch(function(error) {
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        });
                    }
                }
            } else {
                General.openReport("opl_relatorios#/emissao_pedidos_ol_relatorio", reportRow.reportLabel, reportRow).then(success => {}).catch(error => {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            }
        }
    };
    
    //Gera relatório
    this.openReport = function(widget, row, reportName) {
        row.QR2TYPE = widget.currentRow.QR2TYPE;
        row.STRATEGY = widget.currentRow.RELATORIO.split('.')[1];
        General.openReport("opl_relatorios#/emissao_pedidos_ol_relatorio", reportName, row).then(success => {}).catch(error => {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
    };
    
    //Gera relatório de emissao de pedidos ol
    this.openPopupGeraRelatorioEmissao = function(widget, row, reportName) {
        var widgetcmp04900 = templateManager.container.getWidget("cmp04900");
        var widgetGerRelatorioEmissao = templateManager.container.getWidget("geraRelatorioEmissaoWidget");
        const reportRow = widget.getParent().reportRow;
        row = reportRow;
        row.QR2TYPE = widgetGerRelatorioEmissao.currentRow.EXTENSAO;
        row.STRATEGY = widgetcmp04900.currentRow.RELATORIO.split('.')[1];
        //Se a extensão for TXT
        if(widget.currentRow.EXTENSAO == "TXT") {
            General.callRestEngine("opl_relatorios#/procedureVALIDA_ITEMAUTF_OL", "Row", reportRow).then(function(response) {
                //Se for retornado P_ERROS === "N" || "T", não há inconsistencias
                if(response.dataset.data.P_ERROS && response.dataset.data.P_ERROS == "N" || response.dataset.data.P_ERROS == "T"){
                   General.openReport("opl_relatorios#/emissao_pedidos_ol_relatorio", row.reportLabel, row).then(success => {}).catch(error => {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                } else {
                    //Armazena o resultado da procedure
                    const arrayResult = response.dataset.data;
                    //Se fir retornado dados
                    if(arrayResult.length > 0){
                        //Function que valida o tipo de inconsistencia
                        var prodsIncons = validaProdsIncons(arrayResult);
                        //Abre um popup do type "question"
                        MessageService.confirmMessageByCode("INCONS_PROCESSO_EMISSAO").then(function(confirmed) {
                            //Armazena o widget de insconsistencia
                            const inconsistWidget = templateManager.container.getWidget("inconsistenciaProdutosEmissaoWidget");
                            //Seta o dataSource com os dados obtidos pela procedure
                            inconsistWidget.dataSource.data = prodsIncons;
                            //Abre o popup de inconsistencia
                            ScreenService.openPopup(inconsistWidget);
                            inconsistWidget.reload();
                            inconsistWidget.activate();
                        }).catch(function(declined){});
                    }
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("UNKNOWN_ERROR");
            });
        } else {
            General.openReport("opl_relatorios#/emissao_pedidos_ol_relatorio", row.reportLabel, row).then(success => {}).catch(error => {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        }
    };
    
    this.prodQtdeInlineChange = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        adicionaNovoPedidoWidget.enabled = false;
    };
    
    this.prodQtdeInlineCancel = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        adicionaNovoPedidoWidget.enabled = true;
        
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.prodQtdeInlineSave  = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        adicionaNovoPedidoWidget.enabled = true;
        
        widget.commitInlineEdit();
        widget.list();
    };
    
    this.onChangeQtdeInline = function(widget) {
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        
        widgetDadosPedido.setEnabled(false);
        widgetDetalhesPedido.setEnabled(false);
        widget.showCheckbox = false;
    };
    
    this.onCancelInlineEdit = function(widget) {
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        
        if(widget.currentRow.NRPEDEXOL) {
            widgetDadosPedido.enabled = true;
            widgetDetalhesPedido.enabled = true;
        }
        
        widget.showCheckbox = true;
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.onSaveInlineEdit = function(widget) {
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const changedRows = widget.dataSource.data.filter(row => {
            return (row.changed === true);
        });
        const rowsLiberadas = widget.dataSource.data.filter(row => {
            return (row.changed === true && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0 || row.IDBAIXEXOL == 1) && (row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0 || row.IDBAIXENPEOL == 1));
        });
        
        if(rowsLiberadas.length == changedRows.length) {
            MessageService.confirmMessageByCode("QTPROGENPEOL_DELETE_ZERO").then(function(confirmed) {
                rowsLiberadas.forEach(row => {
                   row.NEW_QTPROGENPEOL = row.QTPROGENPEOL_inline;
                   row.OLD_QTPROGENPEOL = row.changed_QTPROGENPEOL;
                   row.CDFILDEST = row.CDFILDEST.substr(0, 4);
                   row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
                });
                
                General.callRestEngine("opl_relatorios#/alteraQuantidadeItemPedidoOLInline", "Row", rowsLiberadas).then(function(response) {
                    if(widget.currentRow.NRPEDEXOL) {
                        widgetDadosPedido.enabled = true;
                        widgetDetalhesPedido.enabled = true;
                    }
                    
                    widget.showCheckbox = true;
                    widget.commitInlineEdit();
                    widget.list();
                    widget.reload();
                    widget.activate();
                    
                    MessageService.showMessageByCode("QTPROGENPEOL_EDIT_SUCCESS");
                }).catch(function(error) {
                    if(widget.currentRow.NRPEDEXOL) {
                        widgetDadosPedido.enabled = true;
                        widgetDetalhesPedido.enabled = true;
                    }
                    
                    widget.showCheckbox = true;
                    widget.rollbackInlineEdit();
                    widget.list();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            });
        } else {
            MessageService.showMessageByCode("ONLY_EMABERTO_PARCIAL_ITENS_PEDIDO_EDIT");
            
            if(widget.currentRow.NRPEDEXOL) {
                widgetDadosPedido.enabled = true;
                widgetDetalhesPedido.enabled = true;
            }
            
            widget.showCheckbox = true;
            widget.rollbackInlineEdit();
            widget.list();
        }
    };
    
    this.cancelaNovoItemPedido = function(widget) {
        MessageService.confirmMessageByCode("CANCEL_NOVO_ITEM_PEDIDO").then(function(confirmed) {
            ScreenService.closeSwipe();
            widget.getParent().activate();
            widget.getParent().list();
        });
    };
    
    this.realizaCalculoPorcentagens = function(widgetAltAutomaticaProd, cdProdutoOld) {
        const fieldAjusteUnidade = widgetAltAutomaticaProd.getField('AJUSTE_UNIDADE');
        const fieldAjusteQuantidade = widgetAltAutomaticaProd.getField('AJUSTE_QUANTIDADE');
        const row = {
            "CDPRODUTO_OLD": cdProdutoOld,
            "CDARVPROD": widgetAltAutomaticaProd.currentRow.CDARVPROD
        };
        
        return General.callRestEngine("opl_relatorios#/calcularAjustesProduto", "Row", row).then(function(response) {
            const ajustes = response.dataset.data[0];
            
            if(!Util.isEmptyOrBlank(ajustes.AJUSTEUN)) {
                if(ajustes.AJUSTEUN == 0 || ajustes.AJUSTEUN == null) {
                    fieldAjusteUnidade.setValue('0');
                } else {
                    fieldAjusteUnidade.setValue(ajustes.AJUSTEUN);
                }
                fieldAjusteUnidade.reload();
            } else {
                fieldAjusteUnidade.setValue('0');
            }
            
            if(!Util.isEmptyOrBlank(ajustes.AJUSTEQTDE)) {
                if(ajustes.AJUSTEQTDE == 0 || ajustes.AJUSTEQTDE == null) {
                    fieldAjusteQuantidade.setValue('0');
                } else {
                    fieldAjusteQuantidade.setValue(ajustes.AJUSTEQTDE);
                }
                fieldAjusteQuantidade.reload();
            } else {
                fieldAjusteQuantidade.setValue('0');
            }
            
            fieldAjusteUnidade.reload();
    		fieldAjusteQuantidade.reload();
        }).catch(function(error) {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
    };
    
    this.verificaProduto = function(field) {
        const widget = field.widget;
        const widgetGrid = widget.getParent();
        const checkedRowsGrid = widgetGrid.getCheckedRows();
        
        if(!Util.isEmptyOrBlank(widget.currentRow.CDARVPROD)) {
            for(let i = 0; i < checkedRowsGrid.length; i++) {
                if(checkedRowsGrid[i].CDARVPROD === widget.currentRow.CDARVPROD) {
                    MessageService.showMessageByCode("NEW_PRODUCT_PRODUCT_ORIGIN");
                    field.clearValue();
                    return;
                }
            }
            this.realizaCalculoPorcentagens(widget, checkedRowsGrid[0].CDARVPROD);
        } else {
            widget.currentRow.AJUSTE_UNIDADE = '0';
            widget.currentRow.AJUSTE_QUANTIDADE = '0';
        }
    };
    
    this.enviaEmail = function(widget) {
        widget.currentRow.MSGOPL = "Email automático enviado pelo Operador Logístico";
        widget.currentRow.MSGDATESENT = "Disponilizado em: ";
        widget.currentRow.DSLINK = "Clique aqui para visualizar o Relatório";
        
        const reportRow = widget.getParent().reportRow;
        const row = {
            "DADOS_EMAIL": widget.currentRow,
            "CURRENT_ROW": reportRow
        };
        
        //Se a extensão for TXT
        if(widget.currentRow.EXTENSAO == "TXT") {
            General.callRestEngine("opl_relatorios#/procedureVALIDA_ITEMAUTF_OL", "Row", reportRow).then(function(response) {
                //Armazena o resultado da procedure
                const arrayResult = response.dataset.data;
                //Se fir retornado dados
                if(arrayResult.length > 0){
                    //Function que valida o tipo de inconsistencia
                    var prodsIncons = validaProdsIncons(arrayResult);
                    //Abre um popup do type "question"
                    MessageService.confirmMessageByCode("INCONS_PROCESSO_EMISSAO").then(function(confirmed) {
                        //Armazena o widget de insconsistencia
                        const inconsistWidget = templateManager.container.getWidget("inconsistenciaProdutosEmissaoWidget");
                        //Seta o dataSource com os dados obtidos pela procedure
                        inconsistWidget.dataSource.data = prodsIncons;
                        //Abre o popup de inconsistencia
                        ScreenService.openPopup(inconsistWidget);
                        inconsistWidget.reload();
                        inconsistWidget.activate();
                    }).catch(function(declined){});
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("UNKNOWN_ERROR");
            });
        } else {
            if(widget.isValid()) {
                ServiceEmissaoPedidoOL.enviaEmailEmissaoPedidoOL(row).then(function(success) {
                    exibeLogEmail(widget, success.messages, false);
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            }
        }
    };
    
    function exibeLogEmail(widget, success, isGroup) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        const arrayMesssages = widget.currentRow.MSGARRAY;
        let arrayError = [];
        let arraySuccess = [];
        let arrayLogs = [];
        let addHeadSuccess = true;
        let addHeadError = true;
        
        success.forEach(function(row) {
            const logSuccess = row.message.SUCCESS;
            const logError = row.message.ERROR;
        
			if(!Util.isEmptyOrBlank(logSuccess)) {
			    if(addHeadSuccess) {
				    addHeadSuccess = false;
				    arraySuccess = arraySuccess.concat(setArrayLog(logSuccess, arrayMesssages));
				    adicionaCabecalhoAoLog(arraySuccess, arrayMesssages.SUCCESS_MESSAGE);
			    } else {
			        arraySuccess = arraySuccess.concat(setArrayLog(logSuccess, arrayMesssages));
			    }
			}
			
			if(!Util.isEmptyOrBlank(logError)) {
			    if(addHeadError) {
				    addHeadError = false;
				    arrayError = arrayError.concat(setArrayLog(logError, arrayMesssages));
				    adicionaCabecalhoAoLog(arrayError, arrayMesssages.ERROR_MESSAGE);
			    } else {
			        arrayError = arrayError.concat(setArrayLog(logError, arrayMesssages));
			    }
			}
        });

        arrayLogs = arrayError.concat(arraySuccess);
        ScreenService.closePopup();
        General.showErrorMessages(widgetOrigem, arrayLogs, ScreenService.i18n('Log'));
    }
    
    function adicionaCabecalhoAoLog(logArray, titulo) {
        logArray.unshift('----------------------------');
        logArray.unshift(titulo);
        logArray.unshift('----------------------------');
    }
    
    function setArrayLog(messages, arrayMesssages) {
        let result = [];
        
        messages.forEach(row => {
    		result.push(arrayMesssages[row.MESSAGE]);
		});
		
		return result;
    }
    
    this.changeFilterProduct = function(field) {
        field.dataSourceFilter.forEach(function(row) {
            if(row.name == "P_CDFILIOPELOG") {
                row.value = CDFILIOPELOGPROD;
            }
        });
        
        field.reload();
    };
    
    function verificaPermissaoItem(widget, item) {
        if(Util.isEmptyOrBlank(permissoesFinaisOperador)) {
            if(Util.isEmptyOrBlank(permissoesGeraisOperador)) {
                return true;
            } else {
                if(permissoesGeraisOperador.indexOf("BLOL") != -1) {
                    if(item.IDITMPEDOLBLOQ == 'S') {
                        return false;
                    } else {
                        return true;
                    }
                } else {
                    return true;
                }
            }
        } else {
            if(Util.isEmptyOrBlank(permissoesGeraisOperador)) {
                return true;
            } else {
                if(permissoesGeraisOperador.indexOf("BLOL") != -1 && permissoesFinaisOperador.indexOf("BLOL") != -1) {
                    return true;
                } else {
                    if(item.IDITMPEDOLBLOQ == 'S') {
                        return false;
                    } else {
                        return true;
                    }
                }
            }
        }
    }
    
    this.onFieldInlineEdit = function(widget, args) {
        if(!verificaPermissaoItem(widget, args.row)) {
            MessageService.showMessageByCode("OPER_BLOCK");
            widget.rollbackInlineEdit();
            widget.list();
            widget.reload();
            widget.showCheckbox = true;
        }
    };
    
    this.clearProduto = function(widget) {
        widget.getField("NMPRODUTO").clearValue();
        widget.getField("NMPRODUTO").reload();
    };
    
    this.validaSegMercadoProdFili = function(field) {
        ScreenService.showLoader();
        
        var row = {};
        
        
        if(field.widget.name == "adicionaItemPedido") {
            row.CDFILDEST = field.widget.currentRow.CDFILDEST;
        } else {
            field.dataSourceFilter.forEach(f => {
                if(f.name == "CDFILIAL")
                    row.CDFILDEST = f.value;
            });
        }
        
        
        row.CDARVPROD = field.widget.currentRow.CDARVPROD;
        
        if(!Util.isEmptyOrBlank(row.CDARVPROD)) {
            General.callRestEngine("opl_relatorios#/validaSegMercadoProdFili", "Row", row).then(function(response) {
                ScreenService.hideLoader();
            }).catch(function(error) {
                ScreenService.hideLoader();
                
                if(error.data.error == "PRODUTO_NOT_SEGMERCADO" || error.data.error == "PRODUTO_NOT_PRODFILI_ATIVO") {
                    MessageService.showMessageByCode(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                }
                
                field.clearValue();
            });
        } else {
            ScreenService.hideLoader();
        }
    };
    
    //Ativa o widget principal
    this.activateWidgetPrincipal = function(){
        const widgetCmp04900 = templateManager.container.getWidget("cmp04900");
        widgetCmp04900.activate();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("EmissaoPedidosOLController", EmissaoPedidosOLController);
});